package com.adc.da.vdaims.service;

import com.adc.da.vdaims.entity.SyxySerialNumberEO;
import com.adc.da.mp.base.IBaseService;
import com.adc.da.vdaims.enums.SerialNumberType;
import com.adc.da.vdaims.vo.SerialNumberVo;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 纸张编号管理 服务类
 * </p>
 * 作者 gen
 * 日期 2021-08-27
 */
public interface ISyxySerialNumberEOService extends IBaseService<SyxySerialNumberEO> {

    /**
     * 初始化加载纸张编号到缓存
     */
    void initSerialNumber();

    /**
     * 获取下一个纸张编号
     * @param qyId
     * @param type
     * @return
     */
    String getNextSerialNumber(String qyId, SerialNumberType type);

    void updateSerialNumber(SerialNumberVo serialNumberVo);

    void addSerialNumber(String qyId, SerialNumberVo serialNumberVo);

    void delSerialNumber(String qyId, List<String> ids);
}
