package com.adc.da.vdaims.service.impl;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.lang.Assert;
import com.adc.da.enums.CertificateVersionNumner;
import com.adc.da.enums.ConfigSeqEnum;
import com.adc.da.util.exception.AdcDaBaseException;
import com.adc.da.util.utils.StringUtils;
import com.adc.da.util.utils.UserUtil;
import com.adc.da.vdaims.dao.CertConfigSeqTemplateEODao;
import com.adc.da.vdaims.entity.*;
import com.adc.da.vdaims.enums.ConfirmStatus;
import com.adc.da.vdaims.enums.PrintStatus;
import com.adc.da.vdaims.enums.SerialNumberType;
import com.adc.da.vdaims.service.*;
import com.adc.da.vdaims.util.StringUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.Serializable;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 * 作者 gen
 * 日期 2021-08-31
 */
@Service
@Transactional
public class CertConfigSeqTemplateEOServiceImpl extends ServiceImpl<CertConfigSeqTemplateEODao, CertConfigSeqTemplateEO> implements ICertConfigSeqTemplateEOService {
    @Autowired
    IVehicleCertEOService vehicleCertEOService;
    @Autowired
    private IYzxTemplateDataEOService yzxTemplateDataEOService;
    @Autowired
    private IYzxBaseDataEOService yzxBaseDataEOService;
    @Autowired
    private ISyxySerialNumberEOService syxySerialNumberEOService;
    @Autowired
    private ISyxyEnvironmentalDataEOService syxyEnvironmentalDataEOService;
    @Autowired
    private ICertHgzPrintEOService certHgzPrintEOService;
    @Autowired
    private IConfigSeqEOService configSeqEOService;
    @Autowired
    private ISyxyModelEnviromentalDataEOService modelEnviromentalDataEOService;

    @Override
    public boolean importVehilceCerts(List<VehicleCertEO> vehicleCertEOList) {
        boolean result = false;
        String qyId = UserUtil.getQyId();
        String userId = UserUtil.getCurrentUserId();
        Date sysDate = new Date();
        for (VehicleCertEO vehicleCertEO : vehicleCertEOList) {
//            if (StringUtil.isEmpty(vehicleCertEO.getHgzCertno()))
            QueryWrapper<VehicleCertEO> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq(VehicleCertEO.VEHICLE_CERT_VIN, vehicleCertEO.getVin());
            queryWrapper.eq(VehicleCertEO.VEHICLE_CERT_QY_ID, qyId);
            VehicleCertEO oldVehicleCertEO = vehicleCertEOService.getOne(queryWrapper);
            YzxTemplateDataEO yzxTemplateDataEO = null;
            if (null != oldVehicleCertEO) {
                //20211018zh新增校验--导入模板数据之前加校验，如果该企业的数据已确认，则进行提示
                QueryWrapper<CertHgzPrintEO> queryWrapperHgzprint = new QueryWrapper<>();
                queryWrapperHgzprint.eq(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_CLSBDH, vehicleCertEO.getVin())
                        .eq(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_QYID, qyId);
                CertHgzPrintEO certHgzPrintEO = certHgzPrintEOService.getOne(queryWrapperHgzprint);
                if (!StringUtils.isEmpty(certHgzPrintEO)) {
                    throw new AdcDaBaseException("包含Vin为" + vehicleCertEO.getVin() + "的车型数据已确认，请删除或退回后重新导入");
                }

                vehicleCertEO.setId(oldVehicleCertEO.getId());
                vehicleCertEOService.checkUpdate(vehicleCertEO);
                if (vehicleCertEO.getVin().trim().length() != 17) {
                    throw new AdcDaBaseException("车辆识别代号长度应为17位");
                }
                if (StringUtil.isEmpty(vehicleCertEO.getHgzCertno()) && StringUtil.isEmpty(vehicleCertEO.getDphgzCertno())) {
                    throw new AdcDaBaseException("合格证编号和底盘合格证编号不能同时为空");
                }
                UpdateWrapper<VehicleCertEO> updateWrapper = new UpdateWrapper<>();
                updateWrapper.eq(VehicleCertEO.VEHICLE_CERT_VIN, vehicleCertEO.getVin());
                updateWrapper.eq(VehicleCertEO.VEHICLE_CERT_QY_ID, UserUtil.getCurrentUserName());
                result = vehicleCertEOService.update(vehicleCertEO, updateWrapper);
                if (!StringUtils.equals(oldVehicleCertEO.getYzxCertno(), vehicleCertEO.getYzxCertno())) {
                    yzxTemplateDataEO = yzxTemplateDataEOService.getById(oldVehicleCertEO.getId());
                }
            } else {
                vehicleCertEOService.checkSave(vehicleCertEO);
                if (vehicleCertEO.getVin().trim().length() != 17) {
                    throw new AdcDaBaseException("车辆识别代号长度应为17位");
                }
                if (StringUtil.isEmpty(vehicleCertEO.getHgzCertno()) && StringUtil.isEmpty(vehicleCertEO.getDphgzCertno())) {
                    throw new AdcDaBaseException("合格证编号和底盘合格证编号不能同时为空");
                }
                result = vehicleCertEOService.save(vehicleCertEO);
            }
            if (!StringUtils.isEmpty(vehicleCertEO.getHbCertno())) {
                //新增校验--导入模板数据之前加校验，如果该企业的数据未确认，则进行提示
                QueryWrapper<SyxyEnvironmentalDataEO> queryWrapperSyxy = new QueryWrapper<>();
                queryWrapperSyxy.eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_CREATE_BY_ID, qyId)
                        .eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_DEL, "0")
                        .eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_INFO_DISCLOSURE_NO, vehicleCertEO.getHbCertno());
                List<SyxyEnvironmentalDataEO> list = syxyEnvironmentalDataEOService.list(queryWrapperSyxy);
                if (list.size() > 0) {
                    throw new AdcDaBaseException("环保信息公开编号为" + vehicleCertEO.getHbCertno() + "的基础数据未确认");
                }
                //是否为第一次导入
                if (null != oldVehicleCertEO) {
                    //环保单号一致更新已生成的环保清单证书参数
                    if (vehicleCertEO.getHbCertno().equals(oldVehicleCertEO.getHbCertno())) {
                        updateHB(vehicleCertEO.getVin(), vehicleCertEO);
                    } else {
                        //不一致则删除已存在的环保证书
                        QueryWrapper<SyxyModelEnviromentalDataEO> delWrapper = new QueryWrapper<>();
                        delWrapper.eq(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN, vehicleCertEO.getVin());
                        modelEnviromentalDataEOService.remove(delWrapper);
                    }
                }
            } else {//如果为空，考虑是否为单车新增，也同步更新已存在的环保清单数据
                updateHB(vehicleCertEO.getVin(), vehicleCertEO);
            }
            if (!StringUtils.isEmpty(vehicleCertEO.getYzxCertno())) {
                if (yzxTemplateDataEO == null) {
                    yzxTemplateDataEO = new YzxTemplateDataEO();
                }
                YzxBaseDataEO yzxBaseDataEO = yzxBaseDataEOService.getOne(new QueryWrapper<YzxBaseDataEO>().eq(YzxBaseDataEO.COC_ID, vehicleCertEO.getYzxCertno())
                        .eq(YzxBaseDataEO.QY_ID, qyId), false);
                if (yzxBaseDataEO == null) {
                    throw new AdcDaBaseException("一致性基础数据不存在，请同步一致性基础数据");
                }
                if (!ConfirmStatus.CONFIRMED.getValue().equals(yzxBaseDataEO.getConfirmStatus())) {
                    throw new AdcDaBaseException("COC证书编号为" + yzxBaseDataEO.getCocId() + "的基础数据未确认");
                }
                BeanUtils.copyProperties(yzxBaseDataEO, yzxTemplateDataEO);
                yzxTemplateDataEO.setId(vehicleCertEO.getId())
                        .setYzxPageNo(syxySerialNumberEOService.getNextSerialNumber(qyId, SerialNumberType.YZXZSDY))
                        .setDriveNo(vehicleCertEO.getFdjNo())
                        .setConfirmStatus(ConfirmStatus.NOT_CONFIRM.getValue())
                        .setPrintStatus(PrintStatus.NOT_PRINT.getValue())
                        .setCreateTime(sysDate)
                        .setCreator(userId)
                        .setUpdateTime(sysDate)
                        .setUpdater(userId);
                yzxTemplateDataEOService.saveOrUpdate(yzxTemplateDataEO);
            }


        }
        return result;
    }


    @Override
    public boolean copyTemplate(Serializable templateId, String style) {
        CertConfigSeqTemplateEO oldTemplate = getById(templateId);
        Assert.notNull(oldTemplate, "参数错误");
        Assert.notBlank(style, "款型不能为空");
        if (style.equals(oldTemplate.getStyle())) {
            throw new AdcDaBaseException("复制款型不能与原款型相同，请重新输入");
        }
        QueryWrapper<CertConfigSeqTemplateEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(CertConfigSeqTemplateEO.CERT_CONFIG_SEQ_TEMPLATE_CONFIG_SEQ_NO, oldTemplate.getConfigSeqNo());
        queryWrapper.eq(CertConfigSeqTemplateEO.CERT_CONFIG_SEQ_TEMPLATE_STYLE, style);
        if (CollectionUtil.isNotEmpty(list(queryWrapper))) {
            throw new AdcDaBaseException("相同序列号的该款型已存在，请重新输入");
        }
        CertConfigSeqTemplateEO newTemplate = new CertConfigSeqTemplateEO();
        BeanUtils.copyProperties(oldTemplate, newTemplate);
        newTemplate.setId(null);
        newTemplate.setSource(1);
        newTemplate.setStyle(style);
        newTemplate.setCreator(null);
        newTemplate.setCreateTime(null);
        return save(newTemplate);
    }


    @Override
    public boolean rebackTemplate(Serializable... templateIds) {
        if (CollectionUtil.isEmpty(Arrays.asList(templateIds))) {
            return true;
        }
        QueryWrapper<CertConfigSeqTemplateEO> configSeqTemplateEOQueryWrapper = new QueryWrapper<>();
        configSeqTemplateEOQueryWrapper.in(CertConfigSeqTemplateEO.CERT_CONFIG_SEQ_TEMPLATE_ID, templateIds);
        List<CertConfigSeqTemplateEO> configSeqTemplateEOList = list(configSeqTemplateEOQueryWrapper);
        if (CollectionUtil.isEmpty(configSeqTemplateEOList)) {
            return true;
        }
        for (CertConfigSeqTemplateEO certConfigSeqTemplateEO : configSeqTemplateEOList) {
            //处理每个模板
            QueryWrapper<VehicleCertEO> vehicleCertEOQueryWrapper = new QueryWrapper<>();
            vehicleCertEOQueryWrapper.eq(VehicleCertEO.VEHICLE_CERT_CONFIG_SEQ_NO, certConfigSeqTemplateEO.getConfigSeqNo());
            vehicleCertEOQueryWrapper.eq("VEHICLE_STYLE", certConfigSeqTemplateEO.getStyle());
            List<VehicleCertEO> vehicleCertEOList = vehicleCertEOService.list(vehicleCertEOQueryWrapper);
            if (CollectionUtil.isNotEmpty(vehicleCertEOList)) {
                //处理模板的证书
                List<String> vinList = vehicleCertEOList.stream().map(VehicleCertEO::getVin).collect(Collectors.toList());
                QueryWrapper<CertHgzPrintEO> certHgzPrintEOQueryWrapper = new QueryWrapper<>();
                certHgzPrintEOQueryWrapper.in(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_CLSBDH, vinList);
                certHgzPrintEOQueryWrapper.eq("HGZ_STATUS", CertificateVersionNumner.UPLOAD.getValue());
                if (CollectionUtil.isNotEmpty(certHgzPrintEOService.list(certHgzPrintEOQueryWrapper))) {
                    throw new AdcDaBaseException(certConfigSeqTemplateEO.getTemplateName() + "模板下存在已上传合格证数据，不允许回退");
                } else {
                    //进行回退,删除CERT_CONFIG_SEQ_TEMPLATE，修改CERT_CONFIG_SEQ状态,删除CERT_HGZ_PRINT,修改VEHICLE_CERT状态
                    removeById(certConfigSeqTemplateEO.getId());

                    ConfigSeqEO configEO = configSeqEOService.getById(certConfigSeqTemplateEO.getConfigSeqId());
                    configEO.setStatus(ConfigSeqEnum.EDIT.getCode());
                    configSeqEOService.updateById(configEO);

                    QueryWrapper<CertHgzPrintEO> deleteWapper = new QueryWrapper<>();
                    deleteWapper.in(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_CLSBDH, vinList);
                    certHgzPrintEOService.remove(deleteWapper);

                    for (VehicleCertEO vehicleCertEO : vehicleCertEOList) {
                        vehicleCertEO.setHgzStatus(0);
                    }
                    vehicleCertEOService.updateBatchById(vehicleCertEOList);

                }
            }

        }
        return false;
    }

    @Override
    public boolean removeByIds(Collection<? extends Serializable> idList) {
        QueryWrapper<CertConfigSeqTemplateEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.in(CertConfigSeqTemplateEO.CERT_CONFIG_SEQ_TEMPLATE_ID, idList);
        List<CertConfigSeqTemplateEO> templateEOList = list(queryWrapper);
        if (CollectionUtil.isNotEmpty(templateEOList)) {
            for (CertConfigSeqTemplateEO certConfigSeqTemplateEO : templateEOList) {
                if (0 == certConfigSeqTemplateEO.getSource()) {
                    throw new AdcDaBaseException("原始数据不允许删除");
                }
                QueryWrapper<VehicleCertEO> vehicleCertEOQueryWrapper = new QueryWrapper<>();
                vehicleCertEOQueryWrapper.eq(VehicleCertEO.VEHICLE_CERT_CONFIG_SEQ_NO, certConfigSeqTemplateEO.getConfigSeqNo());
                vehicleCertEOQueryWrapper.eq(VehicleCertEO.VEHICLE_CERT_VEHICLE_STYLE, certConfigSeqTemplateEO.getStyle());
                vehicleCertEOQueryWrapper.eq(VehicleCertEO.VEHICLE_CERT_HGZ_STATUS, 1);
                if (CollectionUtil.isNotEmpty(vehicleCertEOService.list(vehicleCertEOQueryWrapper))) {
                    throw new AdcDaBaseException("当前模板存在已确认车辆，不允许删除");
                }
            }
        }
        return super.removeByIds(idList);
    }


    @Override
    public String validateVehilceCerts(List<VehicleCertEO> vehicleCertEOList) {
        String resultVins = "";
        String qyId = UserUtil.getQyId();
        for (VehicleCertEO vehicleCertEO : vehicleCertEOList) {
            //新增校验--查询是否包含已申报VIN
            String vin = vehicleCertEO.getVin();                // vin
            String validateResults = validateVinPush(vin);
            if (!"".equals(validateResults)) {
                throw new AdcDaBaseException(validateResults);
            }
            //新增校验--环保清单证书是否确认
            validateHBno(vehicleCertEO.getHbCertno());
            //新增校验--一致性证书是否确认
            validateYzxBaseData(vehicleCertEO.getHbCertno());
            //新增校验--导入模板数据之前加校验，如果该企业的数据已确认，则进行提示
            QueryWrapper<CertHgzPrintEO> queryWrapperHgzprint = new QueryWrapper<>();
            queryWrapperHgzprint.eq(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_CLSBDH, vehicleCertEO.getVin())
                    .eq(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_QYID, qyId);
            CertHgzPrintEO certHgzPrintEO = certHgzPrintEOService.getOne(queryWrapperHgzprint);
            if (!StringUtils.isEmpty(certHgzPrintEO)) {
                throw new AdcDaBaseException("导入的Vin为" + vehicleCertEO.getVin() + "已存在且已确认，若要重新导入，请将数据删除或退回后再重新导入！");
            }
            String resultvin = validateVehilceCertDate(vehicleCertEO);
            if (StringUtils.isNotEmpty(resultvin)) {
                resultVins = resultVins + resultvin + ";";
            }
        }
        return resultVins;
    }

    /*更新环保清单单车信息*/
    public void updateHB(String vin, VehicleCertEO EO) {
        QueryWrapper<SyxyModelEnviromentalDataEO> querySyxyModelEnviromentalWrapper = new QueryWrapper<>();
        querySyxyModelEnviromentalWrapper.eq(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN, vin);
        SyxyModelEnviromentalDataEO oldSyxyModelEnviromentalDataEO = modelEnviromentalDataEOService.getOne(querySyxyModelEnviromentalWrapper);
        if (StringUtils.isNotEmpty(oldSyxyModelEnviromentalDataEO)) {
            oldSyxyModelEnviromentalDataEO.setFdjNo(EO.getFdjNo());
            oldSyxyModelEnviromentalDataEO.setProduceDate(EO.getProduceDate());
            UpdateWrapper<SyxyModelEnviromentalDataEO> updateWrapper = new UpdateWrapper<>();
            updateWrapper.eq(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN, EO.getVin());
            modelEnviromentalDataEOService.update(oldSyxyModelEnviromentalDataEO, updateWrapper);
        }
    }

    /*更新一致性证书单车信息*/
    public void updateyzx(String Yzx_ID, VehicleCertEO EO) {
        QueryWrapper<YzxTemplateDataEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(YzxTemplateDataEO.ID, Yzx_ID);
        YzxTemplateDataEO oldYzxTemplateDataEO = yzxTemplateDataEOService.getOne(queryWrapper);
//        if (StringUtils.isNotEmpty(oldYzxTemplateDataEO)) {
//            oldYzxTemplateDataEO.setDriveNo(EO.getFdjNo());
//            oldYzxTemplateDataEO.setDriveNoHh(EO.getQddjNo());
//            oldYzxTemplateDataEO.setProduceDate(EO.getProduceDate());
//            UpdateWrapper<SyxyModelEnviromentalDataEO> updateWrapper = new UpdateWrapper<>();
//            updateWrapper.eq(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN, EO.getVin());
//            modelEnviromentalDataEOService.update(oldSyxyModelEnviromentalDataEO, updateWrapper);
//        }
    }

    /*判断环保清单证书是否确认*/
    public void validateHBno(String no) {
        if (StringUtils.isNotEmpty(no)) {
            String qyId = UserUtil.getQyId();
            QueryWrapper<SyxyEnvironmentalDataEO> queryWrapperSyxy = new QueryWrapper<>();
            queryWrapperSyxy.eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_CREATE_BY_ID, qyId)
                    .eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_DEL, "0")
                    .eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_INFO_DISCLOSURE_NO, no);
            List<SyxyEnvironmentalDataEO> list = syxyEnvironmentalDataEOService.list(queryWrapperSyxy);
            if (list.size() > 0) {
                throw new AdcDaBaseException("环保信息公开编号为" + no + "的基础数据未确认");
            }
        }
    }

    /*判断一致性证书是否确认*/
    public void validateYzxBaseData(String no) {
        if (StringUtils.isNotEmpty(no)) {
            String qyId = UserUtil.getQyId();
            YzxBaseDataEO yzxBaseDataEO = yzxBaseDataEOService.getOne(new QueryWrapper<YzxBaseDataEO>().eq(YzxBaseDataEO.COC_ID, no)
                    .eq(YzxBaseDataEO.QY_ID, qyId), false);
            if (yzxBaseDataEO == null) {
                throw new AdcDaBaseException("一致性基础数据不存在，请同步一致性基础数据");
            }
            if (!ConfirmStatus.CONFIRMED.getValue().equals(yzxBaseDataEO.getConfirmStatus())) {
                throw new AdcDaBaseException("COC证书编号为" + yzxBaseDataEO.getCocId() + "的基础数据未确认");
            }
        }
    }

    /*判断是否VIN已报送*/
    public String validateVinPush(String vin) {
        QueryWrapper<VehicleCertEO> querWrapperyz = new QueryWrapper<>();
        querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_VIN, vin);
        VehicleCertEO vehicleCertEO = vehicleCertEOService.getOne(querWrapperyz);
        if (vehicleCertEO != null) {
            QueryWrapper<SyxyModelEnviromentalDataEO> queryHbWrapper = new QueryWrapper<>();
            queryHbWrapper.eq(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN, vin)
                    .eq(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN_STATE, "1");
            List<SyxyModelEnviromentalDataEO> hblist = modelEnviromentalDataEOService.list(queryHbWrapper);
            if (hblist.size() > 0) {
                return "该VIN:【" + vin + "】对应环保信息公开编号的车已经申报！";
            }

            //校验该Vin 对应的合格证数据是否已经申报
//                hgz_status  -- 3 表示 已申报
            QueryWrapper<CertHgzPrintEO> queryHgzWrapper = new QueryWrapper<>();
            queryHgzWrapper.eq(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_CLSBDH, vin).eq("HGZ_STATUS", "3");
            List<CertHgzPrintEO> hgzlist = certHgzPrintEOService.list(queryHgzWrapper);
            if (hgzlist.size() > 0) {
                return "该VIN:【" + vin + "】对应合格证编号的车已经申报！";
            }

            //校验该Vin 对应的一致性数据是否已经申报
            //先根据vin查VEHICLE_CERT_VIN对应的ID
            String yzxid = vehicleCertEO.getId();
            //根据ID查询申报状态
            QueryWrapper<YzxTemplateDataEO> queryYzWrapper = new QueryWrapper<>();
            queryYzWrapper.eq(YzxTemplateDataEO.ID, yzxid).eq(YzxTemplateDataEO.DECLARE_STATUS, "1");
            List<YzxTemplateDataEO> yzlist = yzxTemplateDataEOService.list(queryYzWrapper);
            if (yzlist.size() > 0) {
                return "该VIN:【" + vin + "】对应一致性证书编号的车已经申报！";
            }
        }
        return "";
    }

    public String validateVehilceCertDate(VehicleCertEO vehicleCertEO) {
        QueryWrapper<VehicleCertEO> querWrapperyz = new QueryWrapper<>();
        querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_VIN, vehicleCertEO.getVin());

        List<VehicleCertEO> vehicleCertList = vehicleCertEOService.list(querWrapperyz);
        VehicleCertEO vehicleCert = vehicleCertEOService.getOne(querWrapperyz);
        if (StringUtils.isNotEmpty(vehicleCert)) {
            if (StringUtils.isNotEmpty(vehicleCertEO.getHbCertno())) {//环保证书编号
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_HB_CERTNO, vehicleCertEO.getHbCertno());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getYzxCertno())) {//一致性证书编号
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_YZX_CERTNO, vehicleCertEO.getYzxCertno());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getHgzCertno())) {//合格证编号
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_HGZ_CERTNO, vehicleCertEO.getHgzCertno());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getDphgzCertno())) {//底盘合格证编号
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_DPHGZ_CERTNO, vehicleCertEO.getDphgzCertno());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getFdjNo())) {//发动机编号
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_FDJ_NO, vehicleCertEO.getFdjNo());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getPageNo())) {//合格证纸张编号
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_PAGE_NO, vehicleCertEO.getPageNo());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getQddjNo())) {//驱动电机编号
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_QDDJ_NO, vehicleCertEO.getQddjNo());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getConfigSeqNo())) {//配置序列号
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_CONFIG_SEQ_NO, vehicleCertEO.getConfigSeqNo());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getProduceDate())) {//制造日期
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_PRODUCE_DATE, vehicleCertEO.getProduceDate());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getCertDate())) {//发证日期
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_CERT_DATE, vehicleCertEO.getCertDate());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getVehicleColor())) {//车身颜色
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_VEHICLE_COLOR, vehicleCertEO.getVehicleColor());
            }
            if (StringUtils.isNotEmpty(vehicleCertEO.getVehicleStyle())) {//款型
                querWrapperyz.eq(VehicleCertEO.VEHICLE_CERT_VEHICLE_STYLE, vehicleCertEO.getVehicleStyle());
            }
            List<VehicleCertEO> vehicleCer = vehicleCertEOService.list(querWrapperyz);
            if (vehicleCer.size() > 0) {
                return "";
            } else {
                return vehicleCertEO.getVin();
            }
        } else {
            return "";
        }

    }
}
