package com.adc.da.vdaims.service.impl;

import com.adc.da.util.utils.UserUtil;
import com.adc.da.vdaims.entity.CertPrintAllEO;
import com.adc.da.vdaims.entity.VehicleCertEO;
import com.adc.da.vdaims.entity.YzxTemplateDataEO;
import com.adc.da.vdaims.entity.SyxyModelEnviromentalDataEO;
import com.adc.da.vdaims.dao.CertPrintAllEODao;
import com.adc.da.vdaims.enums.ConfirmStatus;
import com.adc.da.vdaims.enums.PrintStatus;
import com.adc.da.vdaims.exception.BusinessException;
import com.adc.da.vdaims.service.ICertPrintAllEOService;
import com.adc.da.vdaims.service.IVehicleCertEOService;
import com.adc.da.vdaims.service.IYzxTemplateDataEOService;
import com.adc.da.vdaims.service.ISyxyModelEnviromentalDataEOService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 * 作者 gen
 * 日期 2021-09-13
 */
@Service
public class CertPrintAllEOServiceImpl extends ServiceImpl<CertPrintAllEODao, CertPrintAllEO> implements ICertPrintAllEOService {
    @Autowired
    private IVehicleCertEOService vehicleCertEOService;
    @Autowired
    private IYzxTemplateDataEOService yzxTemplateDataEOService;
    @Autowired
    private ISyxyModelEnviromentalDataEOService modelEnviromentalDataEOService;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void batchApplyBack(List<String> idList) {
        String qyId = UserUtil.getQyId();
        Collection<CertPrintAllEO> certPrintAllEOList = this.query().in(CertPrintAllEO.CERT_PRINT_ALL_ID, idList).eq(CertPrintAllEO.CERT_PRINT_ALL_QY_ID, qyId).list();
        List<String> vehicleCertIdList = new ArrayList<>();
        List<String> vinList = new ArrayList<>();
        for (CertPrintAllEO certPrintAllEO : certPrintAllEOList) {
            if (!PrintStatus.NOT_PRINT.getValue().equals(certPrintAllEO.getHgzStatus()) ||
                    !PrintStatus.NOT_PRINT.getValue().equals(certPrintAllEO.getYzxStatus()) ||
                    !PrintStatus.NOT_PRINT.getValue().equals(certPrintAllEO.getHbStatus())) {
                throw new BusinessException("证书已被打印，无法退回！");
            }
            vehicleCertIdList.add(certPrintAllEO.getId());
            vinList.add(certPrintAllEO.getVin());
        }
        vehicleCertEOService.update().set(VehicleCertEO.VEHICLE_CERT_HGZ_STATUS, ConfirmStatus.NOT_CONFIRM.getValue()).in(VehicleCertEO.VEHICLE_CERT_ID, vehicleCertIdList);
        yzxTemplateDataEOService.update().set(YzxTemplateDataEO.CONFIRM_STATUS, ConfirmStatus.NOT_CONFIRM.getValue()).in(YzxTemplateDataEO.ID, vehicleCertIdList);
        modelEnviromentalDataEOService.update().set(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_CONFIRM_STATUS, ConfirmStatus.NOT_CONFIRM.getValue()).in(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN, vinList);
    }
}
