package com.adc.da.vdaims.service.impl;

import com.adc.da.enums.CertDataEnum;
import com.adc.da.enums.CertificateVehicleOrChassis;
import com.adc.da.enums.ConfigSeqEnum;
import com.adc.da.util.exception.AdcDaBaseException;
import com.adc.da.util.utils.UserUtil;
import com.adc.da.vdaims.entity.*;
import com.adc.da.vdaims.dao.CertZkEODao;
import com.adc.da.vdaims.service.*;
import com.adc.da.vdaims.util.StringUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.Serializable;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 * 作者 gen
 * 日期 2021-09-10
 */
@Service
public class CertZkEOServiceImpl extends ServiceImpl<CertZkEODao, CertZkEO> implements ICertZkEOService {
    @Autowired
    IConfigSeqEOService configSeqEOService;

    @Autowired
    IChpdpkZkEOService chpdpkZkEOService;

    @Autowired
    IClcpZkEOService clcpZkEOService;

    @Autowired
    ICertZkExtEOService certZkExtEOService;

    @Autowired
    ICertConfigSeqTemplateEOService certConfigSeqTemplateEOService;

    @Override
    public CertZkEO getByConfigSeq(Serializable configSeqId) {

        ConfigSeqEO configSeqEO = configSeqEOService.getById(configSeqId);
        //整车
        QueryWrapper<CertZkEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(CertZkEO.CERT_ZK_CONFIG_SEQ_ID, configSeqId);
        CertZkEO certZkEO = getOne(queryWrapper);
        if (null == certZkEO) {
            if (configSeqEO.getType().equals(CertificateVehicleOrChassis.VEHICLE.getFlag())) {
                ClcpZkEO clcpZkEO = clcpZkEOService.getVehicleZKByConfigSeq(configSeqId);
                if (null != clcpZkEO) {
                    certZkEO = new CertZkEO();
                    certZkEO.setVehicleType(configSeqEO.getVehicleType());
                    certZkEO.setType(CertificateVehicleOrChassis.VEHICLE.getFlag());
                    certZkEO.setConfigSeqId((String) configSeqId);
                    BeanUtils.copyProperties(clcpZkEO, certZkEO);
                    certZkEO.setCreateTime(null);
                    certZkEO.setUpdateTime(null);
                    certZkEO.setCreator(null);
                    certZkEO.setUpdater(null);
                    certZkEO.setDpModel(clcpZkEO.getDpModel());
                    Map<String, Object> currentUserInfo = UserUtil.getCurrentUserInfo();
                    certZkEO.setEnterpriseName((String) currentUserInfo.get("NAME"));
                    saveOrUpdate(certZkEO);
                } else {
                    certZkEO = new CertZkEO();
                }


            } else {
                ChpdpkZkEO chpdpkZkEO = chpdpkZkEOService.getByBatchAndModel(configSeqEO.getBatch(), configSeqEO.getModel(), configSeqEO.getProductName());
                if (null != chpdpkZkEO) {
                    certZkEO = new CertZkEO();
                    certZkEO.setType(CertificateVehicleOrChassis.CHASSIS.getFlag());
                    certZkEO.setVehicleType(configSeqEO.getVehicleType());
                    certZkEO.setConfigSeqId((String) configSeqId);
                    BeanUtils.copyProperties(chpdpkZkEO, certZkEO);
                    certZkEO.setCreateTime(null);
                    certZkEO.setUpdateTime(null);
                    certZkEO.setCreator(null);
                    certZkEO.setUpdater(null);
                    saveOrUpdate(certZkEO);
                } else {
                    certZkEO = new CertZkEO();
                }


            }

        }
        return certZkEO;
    }


    @Override
    @Transactional
    public CertZkEO saveOrUpdate(CertZkEO entity, String configSeqId) {
        ConfigSeqEO configSeqEO = configSeqEOService.getById(configSeqId);
        if (ConfigSeqEnum.FINISH.equals(configSeqEO.getStatus())) {
            throw new AdcDaBaseException("当前状态已提交,不可编辑");
        }
        //保存
//        entity.setStatus(CertDataEnum.EDIT.getCode());
        configSeqEO.setStatus(ConfigSeqEnum.EDIT.getCode());
        configSeqEOService.updateById(configSeqEO);
        saveOrUpdate(entity);
        return entity;
    }
}
