package com.adc.da.vdaims.service.impl;

import com.adc.da.util.utils.CollectionUtils;
import com.adc.da.util.utils.UserUtil;
import com.adc.da.vdaims.entity.ChpdpkZkEO;
import com.adc.da.vdaims.dao.ChpdpkZkEODao;
import com.adc.da.vdaims.entity.ClcpZkEO;
import com.adc.da.vdaims.entity.ConfigSeqEO;
import com.adc.da.vdaims.service.IChpdpkZkEOService;
import com.adc.da.vdaims.service.IConfigSeqEOService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 * 作者 gen
 * 日期 2021-08-26
 */
@Service
public class ChpdpkZkEOServiceImpl extends ServiceImpl<ChpdpkZkEODao, ChpdpkZkEO> implements IChpdpkZkEOService {
    @Autowired
    IConfigSeqEOService configSeqEOService;

    @Override
    public ChpdpkZkEO getByConfigSeq(Serializable configSeqId) {
        ConfigSeqEO configSeqEO = configSeqEOService.getById(configSeqId);
        //整车
        QueryWrapper<ChpdpkZkEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("底盘型号", configSeqEO.getModel());
        queryWrapper.eq("批次", configSeqEO.getBatch());
        queryWrapper.eq("产品名称", configSeqEO.getProductName());
        queryWrapper.eq("企业ID", UserUtil.getCurrentUserName());
        List<ChpdpkZkEO> chpdpkZkEOList = list(queryWrapper);
        ChpdpkZkEO chpdpkZkEO = null;
        if (CollectionUtils.isNotEmpty(chpdpkZkEOList)) {
            chpdpkZkEO = chpdpkZkEOList.get(0);
        }
        return chpdpkZkEO;
    }


    @Override
    public ChpdpkZkEO getByBatchAndModel(String batch, String model, String productName) {
        QueryWrapper<ChpdpkZkEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("底盘型号", model);
        queryWrapper.eq("批次", batch);
        queryWrapper.eq("产品名称", productName);
        queryWrapper.eq("企业ID", UserUtil.getCurrentUserName());
        List<ChpdpkZkEO> clcpZkEOList = list(queryWrapper);
        ChpdpkZkEO chpdpkZkEO =null;
        if (CollectionUtils.isNotEmpty(clcpZkEOList)) {
            chpdpkZkEO = clcpZkEOList.get(0);
        }
        return chpdpkZkEO;
    }


}
