package com.adc.da.vdaims.service.impl;

import com.adc.da.util.utils.CollectionUtils;
import com.adc.da.util.utils.UserUtil;
import com.adc.da.vdaims.entity.CertClcpZkEO;
import com.adc.da.vdaims.entity.ClcpZkEO;
import com.adc.da.vdaims.dao.ClcpZkEODao;
import com.adc.da.vdaims.entity.ConfigSeqEO;
import com.adc.da.vdaims.service.IClcpZkEOService;
import com.adc.da.vdaims.service.IConfigSeqEOService;
import com.adc.da.vdaims.util.StringUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * <p>
 * 服务实现类
 * </p>
 * 作者 gen
 * 日期 2021-08-24
 */
@Service
public class ClcpZkEOServiceImpl extends ServiceImpl<ClcpZkEODao, ClcpZkEO> implements IClcpZkEOService {
    @Autowired
    IConfigSeqEOService configSeqEOService;

    @Override
    public ClcpZkEO getVehicleZKByConfigSeq(Serializable configSeqId) {
        ConfigSeqEO configSeqEO = configSeqEOService.getById(configSeqId);
        //整车
        QueryWrapper<ClcpZkEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("车辆型号", configSeqEO.getModel());
        queryWrapper.eq("批次", configSeqEO.getBatch());
        queryWrapper.eq("车辆名称", configSeqEO.getProductName());
        queryWrapper.eq("企业ID", UserUtil.getCurrentUserName());
        List<ClcpZkEO> clcpZkEOList = list(queryWrapper);
        ClcpZkEO clcpZkEO = null;
        if (CollectionUtils.isNotEmpty(list(queryWrapper))){
            clcpZkEO = clcpZkEOList.get(0);
            List<String> dpModelList =new ArrayList<>();
            String dqx1=clcpZkEO.getDiCompany1();
            String dqx2=clcpZkEO.getDiCompany2();
            String dqx3=clcpZkEO.getDiCompany3();
            String dqx4=clcpZkEO.getDiCompany4();
            if (StringUtil.isNotEmpty(dqx1)){
                dpModelList.add(filterChinese(dqx1));
            }
            if (StringUtil.isNotEmpty(dqx2)){
                dpModelList.add(filterChinese(dqx2));
            }
            if (StringUtil.isNotEmpty(dqx3)){
                dpModelList.add(filterChinese(dqx3));
            }
            if (StringUtil.isNotEmpty(dqx4)){
                dpModelList.add(filterChinese(dqx4));
            }

            clcpZkEO.setDpModel(StringUtil.joinString(dpModelList,"/"));
//
        }
        return clcpZkEO;
    }

    @Override
    public ClcpZkEO getVehicleZK(String batch, String model,String vehicleName) {
        QueryWrapper<ClcpZkEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("车辆型号", model);
        queryWrapper.eq("批次", batch);
        queryWrapper.eq("车辆名称", vehicleName);
        queryWrapper.eq("企业ID", UserUtil.getCurrentUserName());
        List<ClcpZkEO> clcpZkEOList = list(queryWrapper);
        ClcpZkEO clcpZkEO =null;
        if (CollectionUtils.isNotEmpty(list(queryWrapper))){
            clcpZkEO = clcpZkEOList.get(0);
            List<String> dpModelList =new ArrayList<>();
            String dqx1=clcpZkEO.getDiCompany1();
            String dqx2=clcpZkEO.getDiCompany2();
            String dqx3=clcpZkEO.getDiCompany3();
            String dqx4=clcpZkEO.getDiCompany4();
            if (StringUtil.isNotEmpty(dqx1)){
                dpModelList.add(filterChinese(dqx1));
            }
            if (StringUtil.isNotEmpty(dqx2)){
                dpModelList.add(filterChinese(dqx2));
            }
            if (StringUtil.isNotEmpty(dqx3)){
                dpModelList.add(filterChinese(dqx3));
            }
            if (StringUtil.isNotEmpty(dqx4)){
                dpModelList.add(filterChinese(dqx4));
            }

            clcpZkEO.setDpModel(StringUtil.joinString(dpModelList,"/"));
        }
        return clcpZkEO;
    }

    /**
     * 判断字符串中是否包含中文
     * @param str
     * 待校验字符串
     * @return 是否为中文
     * @warn 不能校验是否为中文标点符号
     */
    public static boolean isContainChinese(String str) {
        Pattern p = Pattern.compile("[\u4e00-\u9fa5]");
        Matcher m = p.matcher(str);
        if (m.find()) {
            return true;
        }
        return false;
    }

    /**
     * 过滤掉中文
     * @param str 待过滤中文的字符串
     * @return 过滤掉中文后字符串
     */
    public static String filterChinese(String str) {
        // 用于返回结果
        String result = str;
        boolean flag = isContainChinese(str);
        if (flag) {// 包含中文
            // 用于拼接过滤中文后的字符
            StringBuffer sb = new StringBuffer();
            // 用于校验是否为中文
            boolean flag2 = false;
            // 用于临时存储单字符
            char chinese = 0;
            // 5.去除掉文件名中的中文
            // 将字符串转换成char[]
            char[] charArray = str.toCharArray();
            // 过滤到中文及中文字符
            for (int i = 0; i < charArray.length; i++) {
                chinese = charArray[i];
                flag2 = isChinese(chinese);
                if (!flag2) {// 不是中日韩文字及标点符号
                    sb.append(chinese);
                }
            }
            result = sb.toString();
        }
        return result;
    }

    /**
     * 判定输入的是否是汉字
     *
     * @param c
     *  被校验的字符
     * @return true代表是汉字
     */
    public static boolean isChinese(char c) {
        Character.UnicodeBlock ub = Character.UnicodeBlock.of(c);
        if (ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS
                || ub == Character.UnicodeBlock.CJK_COMPATIBILITY_IDEOGRAPHS
                || ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS_EXTENSION_A
                || ub == Character.UnicodeBlock.GENERAL_PUNCTUATION
                || ub == Character.UnicodeBlock.CJK_SYMBOLS_AND_PUNCTUATION
                || ub == Character.UnicodeBlock.HALFWIDTH_AND_FULLWIDTH_FORMS) {
            return true;
        }
        return false;
    }
}
