package com.adc.da.vdaims.service.impl;

import com.adc.da.util.utils.CollectionUtils;
import com.adc.da.util.utils.UUID;
import com.adc.da.vdaims.dao.SyxyEnvironmentalDataEODao;
import com.adc.da.vdaims.dao.SyxyInspectionInformationEODao;
import com.adc.da.vdaims.entity.*;
import com.adc.da.vdaims.enums.ConfirmStatus;
import com.adc.da.vdaims.exception.BusinessException;
import com.adc.da.vdaims.service.*;
import com.adc.da.vdaims.util.AjaxJson;
import com.adc.da.vdaims.util.DateUtils;
import com.adc.da.vdaims.util.StringUtil;
import com.adc.da.vdaims.vo.HbqdTemplateInfoVo;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.gson.Gson;
import com.google.gson.internal.LinkedTreeMap;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.exception.ConstraintViolationException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;

import java.io.Serializable;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 * 作者 gen
 * 日期 2021-08-26
 */
@Service
public class SyxyEnvironmentalDataEOServiceImpl extends ServiceImpl<SyxyEnvironmentalDataEODao, SyxyEnvironmentalDataEO> implements ISyxyEnvironmentalDataEOService {

    @Autowired
    private ISyxyEnvSyncRecordEOService iSyxyEnvSyncRecordEOService;
    @Autowired
    private ISyxyEnvironmentalDataEOService environmentalDataEOService;
    @Autowired
    private SyxyEnvironmentalDataEODao environmentalDataEODao;
    @Autowired
    private SyxyInspectionInformationEODao inspectionInformationEODao;
    @Autowired
    private ISyxyInspectionInformationEOService inspectionInformationEOService;
    @Autowired
    private IVehicleCertEOService vehicleCertEOService;
    @Autowired
    private ISyxyModelEnviromentalDataEOService modelEnviromentalDataEOService;
    @Autowired
    private IYzxTemplateDataEOService yzxTemplateDataEOService;
    @Autowired
    private ICertHgzPrintEOService certHgzPrintEOService;

    @Override
    public boolean syncData(String qyid) {
        int certPc = getNoticeRecordPC();
        int envPc = getEnvRecordPC();
        boolean syncSuccess = true;
        for (int i = envPc + 1; i <= certPc; i++) {
//            List<CertificateDataEntity> certificateDataEntities = systemService
//                    .findByProperty(CertificateDataEntity.class, "announcementBatch", i);
//            syncSuccess = syncEvnData(certificateDataEntities);
            String clxh = "";
            List<String> clxhList = new ArrayList<>();
            clxhList.add("SCZ5070ZYS6");  //TODO edit
            syncSuccess = syncEvnData(clxhList, qyid, "");
            // updateEnvSyncPC(i);
        }

        return syncSuccess;
    }

    @Override
    public boolean syncSingleData(String clxh, String qyid) {
//        int certPc = getNoticeRecordPC();
//        int envPc = getEnvRecordPC();
        boolean syncSuccess = true;
//        for (int i = envPc + 1; i <= certPc; i++) {
//            List<String> clxhList = new ArrayList<>();
//            clxhList.add("SCZ5070ZYS6");  //TODO edit
//            syncSuccess = syncEvnData(clxhList);
//            updateEnvSyncPC(i);
//        }
        List<String> clxhList = new ArrayList<>();
        clxhList.add(clxh);
        syncSuccess = syncEvnData(clxhList, qyid, "");
//            updateEnvSyncPC(i);
        return syncSuccess;
    }

    @Override
    public boolean syncAllData(String pc, String qyname, String qyid) {
        //同步之前先看该企业之前是否同步过，如果同步过则不进行重复同步
        QueryWrapper<SyxyEnvSyncRecordEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(SyxyEnvSyncRecordEO.SYXY_ENV_SYNC_RECORD_PC, pc)
                .eq(SyxyEnvSyncRecordEO.SYXY_ENV_SYNC_RECORD_QYMC, qyname);

        List<SyxyEnvSyncRecordEO> list = iSyxyEnvSyncRecordEOService.list(queryWrapper);
        if (list.size() > 0) {   //之前同步过
            return false;
        } else {
            //根据批次，企业名称，企业ID 获取该批次的公告车型数据
            List<VehicleInfoVO> vehicleInfoVOS = environmentalDataEODao.getClxhByPc(pc, qyname, qyid);
//        int certPc = getNoticeRecordPC();
//        int envPc = getEnvRecordPC();
            boolean syncSuccess = true;
//        for (int i = envPc + 1; i <= certPc; i++) {
//            List<CertificateDataEntity> certificateDataEntities = systemService
//                    .findByProperty(CertificateDataEntity.class, "announcementBatch", i);
//            syncSuccess = syncEvnData(certificateDataEntities);
            String clxh = "";
            List<String> clxhList = new ArrayList<>();

//            clxhList.add("SCZ5070ZYS6");  //TODO edit

            for (VehicleInfoVO vehicleInfoVO : vehicleInfoVOS) {
                clxhList.add(vehicleInfoVO.getClxh());
            }
            addEnvSyncPC(Integer.parseInt(pc), qyname, qyid, "0");
            syncSuccess = syncEvnData(clxhList, qyid, pc);
            if (syncSuccess) {
                updateEnvSyncPC(Integer.parseInt(pc), qyname, qyid, "1");
            }
            return syncSuccess;
//        }
        }
    }

    private boolean syncEvnData(List<String> clxhList, String qyid, String pc) {

        SimpleClientHttpRequestFactory requestFactory = new SimpleClientHttpRequestFactory();
        requestFactory.setConnectTimeout(2000);
        requestFactory.setReadTimeout(10 * 60 * 1000);

        for (String clxh : clxhList) {
            try {
                String carType = clxh;
                if (carType != null && !carType.equals("")) {
                    RestTemplate restTemplate = new RestTemplate(requestFactory);
                    String url = "http://127.0.0.1:8181/spider/spider";
                    // String url =
                    // ResourceUtil.getConfigByName("envSpiderUrl");
                    String result = restTemplate.getForObject(url + "/{params}", String.class, carType);
                    AjaxJson ajaxJson = new Gson().fromJson(result, AjaxJson.class);
                    Map<String, Object> attributes = ajaxJson.getAttributes();
                    @SuppressWarnings("unchecked")
                    List<LinkedTreeMap<String, Object>> evnList = (List<LinkedTreeMap<String, Object>>) attributes
                            .get("evnList");
                    @SuppressWarnings("unchecked")
                    List<LinkedTreeMap<String, Object>> evnDetail = (List<LinkedTreeMap<String, Object>>) attributes
                            .get("evnDetail");

                    List<SyxyEnvironmentalDataEO> saveList = new ArrayList<>();
                    for (LinkedTreeMap<String, Object> map : evnList) {
                        SyxyEnvironmentalDataEO environmentalInfoData = new SyxyEnvironmentalDataEO();
                        environmentalInfoData.setPc(pc); //新增批次信息
                        environmentalInfoData.setInfoDisclosureNo((String) map.get("xxgkbh"));
                        environmentalInfoData.setCarModelType((String) map.get("cxxh"));
                        environmentalInfoData.setEngineType((String) map.get("fdjxh"));

                        String openTime = (String) map.get("gksj");
                        if (openTime != null) {
                            environmentalInfoData.setOpenTime(DateUtils.getFromSelf(openTime, false));
                        }
                        environmentalInfoData.setProBusiness((String) map.get("scqy"));
                        environmentalInfoData.setImportBusiness((String) map.get("jkqy"));

//                        environmentalInfoData.setCreateById(ContextUtils.generalCreater());
                        environmentalInfoData.setCreateById(qyid);          //赋予企业ID
                        environmentalInfoData.setDel(BigDecimal.valueOf(0)); //0 表示未确认
                        environmentalInfoData.setPrintSwitch(BigDecimal.valueOf(1));//1表示未确认 正常打印
                        try {
//                            List<EnvironmentalDataEntity> environmentalInfoList = findByProperty(
//                                    EnvironmentalDataEntity.class, "infoDisclosureNo",
//                                    environmentalInfoData.getInfoDisclosureNo());

                            List<SyxyEnvironmentalDataEO> list = environmentalDataEOService.list();
                            if (list.size() > 0) {
//                                QueryWrapper<SyxyEnvironmentalDataEO> queryMtModelWrapper =  new QueryWrapper<>();
//                                queryMtModelWrapper.eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_INFO_DISCLOSURE_NO,(String) map.get("infoDisclosureNo"));
//                                List<SyxyEnvironmentalDataEO> environmentalInfoList = environmentalDataEOService.list(queryMtModelWrapper);
                                QueryWrapper<SyxyEnvironmentalDataEO> queryMtModelWrapper = new QueryWrapper<>();
                                queryMtModelWrapper.eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_INFO_DISCLOSURE_NO, (String) map.get("xxgkbh"));
                                List<SyxyEnvironmentalDataEO> environmentalInfoList = environmentalDataEOService.list(queryMtModelWrapper);

                                if (environmentalInfoList.size() == 0 && environmentalInfoData.getCarModelType() != null
                                        && !environmentalInfoData.getCarModelType().equals("")) {
                                    saveList.add(environmentalInfoData);
                                }
                            } else {
                                saveList.add(environmentalInfoData);
                            }
                        } catch (ConstraintViolationException e) {
                            System.err.println("信息公开编号重复");
                            continue;
                        }
                    }

                    try {
                        //this.batchSave(saveList);
                        environmentalDataEOService.saveBatch(saveList);
                    } catch (ConstraintViolationException e) {
                        System.err.println("数据已存在");
                        continue;
                    }

                    for (LinkedTreeMap<String, Object> map : evnDetail) {
                        try {
//                            List<SyxyEnvironmentalDataEO> environmentalInfoList = findByProperty(
//                                    EnvironmentalDataEntity.class, "infoDisclosureNo",
//                                    (String) map.get("infoDisclosureNo"));

                            QueryWrapper<SyxyEnvironmentalDataEO> queryMtModelWrapper = new QueryWrapper<>();
                            queryMtModelWrapper.eq(SyxyEnvironmentalDataEO.SYXY_ENVIRONMENTAL_DATA_INFO_DISCLOSURE_NO, (String) map.get("infoDisclosureNo"));
                            List<SyxyEnvironmentalDataEO> environmentalInfoList = environmentalDataEOService.list(queryMtModelWrapper);


                            if (environmentalInfoList != null && environmentalInfoList.size() == 1) {
                                SyxyEnvironmentalDataEO environmentalInfoData = environmentalInfoList.get(0);

                                environmentalInfoData.setVehicleDesign((String) map.get("vehicleDesign"));
                                environmentalInfoData.setCarTypeCode((String) map.get("carTypeCode"));
                                environmentalInfoData.setTrademark((String) map.get("trademark"));
                                environmentalInfoData.setCarCategory((String) map.get("carCategory"));
                                environmentalInfoData.setDischargeStage((String) map.get("dischargeStage"));
                                environmentalInfoData.setCarIdentLocation((String) map.get("carIdentLocation"));
                                environmentalInfoData.setCarConstructName((String) map.get("carConstructName"));
                                environmentalInfoData.setFactoryAddress((String) map.get("factoryAddress"));
                                environmentalInfoData.setEngineType((String) map.get("engineType"));
                                environmentalInfoData.setCatalystsType((String) map.get("catalystsType"));
                                environmentalInfoData
                                        .setFuelEvaporaControlType((String) map.get("fuelEvaporaControlType"));
                                environmentalInfoData.setOxygenSensorType((String) map.get("oxygenSensorType"));
                                environmentalInfoData.setCrankEmisControlType((String) map.get("crankEmisControlType"));
                                environmentalInfoData.setErgType((String) map.get("ergType"));
                                environmentalInfoData.setObdType((String) map.get("obdType"));
                                environmentalInfoData.setIuprMonitorFunction((String) map.get("iuprMonitorFunction"));
                                environmentalInfoData.setEcuModelVersionNum((String) map.get("ecuModelVersionNum"));
//                                environmentalInfoData.setGearboxTypeGearNum((String) map.get("gearboxTypeGearNum"));
                                environmentalInfoData.setGerboxTypeGearNum((String) map.get("gearboxTypeGearNum"));
                                environmentalInfoData.setMufflerModel((String) map.get("mufflerModel"));
                                environmentalInfoData.setSuperchargerModel((String) map.get("superchargerModel"));
//                                environmentalInfoData.setHeartShapeType((String) map.get("heartShapeType"));
                                environmentalInfoData.setHeartshapetype((String) map.get("heartShapeType"));
                                environmentalInfoData.setEnterpriseInfoPublicUrl((String) map.get("enterpriseInfoPublicUrl"));

                                environmentalInfoData.setLegalRepresentative((String) map.get("legalRepresentative"));
                                environmentalInfoData.setAddress((String) map.get("address"));
                                environmentalInfoData.setMobile((String) map.get("mobile"));

                                environmentalInfoData.setMotorModel((String) map.get("motorModel"));
                                environmentalInfoData.setEnergyStoringModel((String) map.get("energyStoringModel"));
                                environmentalInfoData.setBatteryCapacity((String) map.get("batteryCapacity"));
                                environmentalInfoData.setVehModelVersionNum((String) map.get("vehModelVersionNum"));
                                // 新增
                                environmentalInfoData.setEngineNo((String) map.get("engineNo"));
                                environmentalInfoData.setEngineConstructName((String) map.get("engineConstructName"));
                                environmentalInfoData.setEngineFamilyName((String) map.get("engineFamilyName"));
                                environmentalInfoData.setEngineFactoryAddress((String) map.get("engineFactoryAddress"));
                                environmentalInfoData.setEngineMake((String) map.get("engineMake"));
                                environmentalInfoData.setReprocessModel((String) map.get("reprocessModel"));
//                                environmentalInfoData.setInjectionPumpModel((String) map.get("injectionPumpModel"));
                                environmentalInfoData.setInjectionPumpMoedl((String) map.get("injectionPumpModel"));

                                environmentalInfoData.setInjectorModel((String) map.get("injectorModel"));
                                environmentalInfoData.setGasMixerModel((String) map.get("gasMixerModel"));
                                environmentalInfoData.setGasInjectionUnit((String) map.get("gasInjectionUnit"));
                                environmentalInfoData.setMotorModel((String) map.get("motorModel"));
                                environmentalInfoData.setEnergyStoringModel((String) map.get("energyStoringModel"));
                                environmentalInfoData.setBatteryCapacity((String) map.get("batteryCapacity"));
                                environmentalInfoData.setMaximumNetPower((String) map.get("maximumNetPower"));
                                environmentalInfoData.setMaximumNetTorque((String) map.get("maximumNetTorque"));
                                environmentalInfoData.setFuelSupplySystemType((String) map.get("fuelSupplySystemType"));
                                environmentalInfoData
                                        .setExhaustPostSystemModel((String) map.get("exhaustPostSystemModel"));
                                environmentalInfoData.setPackagCarrierCoating((String) map.get("packagCarrierCoating"));
                                environmentalInfoData
                                        .setExhaustPostSystemType((String) map.get("exhaustPostSystemType"));
                                environmentalInfoData.setAirFilterModel((String) map.get("airFilterModel"));
                                environmentalInfoData.setIntakeMufflerModel((String) map.get("intakeMufflerModel"));
//                                environmentalInfoData.setExHaustMufflerModel((String) map.get("exHaustMufflerModel"));
                                environmentalInfoData.setExhaustMufflerModel((String) map.get("exHaustMufflerModel"));

                                environmentalInfoData.setEvaporatorModel((String) map.get("evaporatorModel"));
                                environmentalInfoData.setHybridModel((String) map.get("hybridModel"));
                                environmentalInfoData.setEjectorModel((String) map.get("ejectorModel"));
                                environmentalInfoData
                                        .setCrankcaseEmissionControl((String) map.get("crankcaseEmissionControl"));
                                environmentalInfoData
                                        .setPressureRegulatorModel((String) map.get("pressureRegulatorModel"));
                                environmentalInfoData.setFuelEmissionControl((String) map.get("fuelEmissionControl"));

                                // 2019-06-10 新增项目
                                //涂层/载体/封装生产厂(催化器型号/生产厂)
                                environmentalInfoData.setPackagCarrierCoating((String) map.get("coatCarrEncapsul"));

                                // 基准质量
                                environmentalInfoData.setJzzl((String) map.get("jzzl"));
                                // 颗粒捕集器型号/生产企业
                                environmentalInfoData.setKlbjqxhScqy((String) map.get("klbjqxhScqy"));
                                // 涂层/载体/封装生产企业（颗粒捕集器型号/生产企业）
                                environmentalInfoData.setTcZtFzscc((String) map.get("tcZtFzscc"));
                                // 炭罐型号/生产企业
                                environmentalInfoData.setTgxhScqy((String) map.get("tgxhScqy"));

                                //20210922新增
                                //OBD接口位置
                                environmentalInfoData.setObdinterfacelocation((String) map.get("obdinterfaceLocation"));
                                //催化转化器（DOC）型号/生产企业
                                environmentalInfoData.setCatalyststypedoc((String) map.get("catalystsTypeDOC"));
                                //封装/载体/涂层生产企业
                                environmentalInfoData.setTcztfzdoc((String) map.get("tcZtFzDoc"));
                                //催化转化器（SCR）型号/生产企业
                                environmentalInfoData.setCatalyststypescr((String) map.get("catalystsTypeSCR"));
                                //封装/载体/涂层生产企业
                                environmentalInfoData.setTcztfzscr((String) map.get("tcZtFzSCR"));
                                //氮氧化物存储催化还原催化转化器型号/生产企业
                                environmentalInfoData.setNitrogenoxidestype((String) map.get("nitrogenOxidesType"));
                                //封装/载体/涂层生产企业
                                environmentalInfoData.setTcztfznitrogenoxides((String) map.get("tcZtFzNitrogenOxides"));
                                //催化转化器（ASC）型号/生产企业
                                environmentalInfoData.setCatalyststypeasc((String) map.get("catalystsTypeASC"));
                                //封装/载体/涂层生产企业
                                environmentalInfoData.setTcztfzasc((String) map.get("tcZtFzASC"));

                                //20210923新增  TODO 修改 部分字段不存在(可能要修改爬数程序)
                                //涂层/载体/封装生产企业
                                environmentalInfoData.setCoatCarrEncapsul((String) map.get("coatCarrEncapsul"));
                                //排气管口位置 （爬虫程序不存在）
                                environmentalInfoData.setExhaustpipeposition((String) map.get("exhaustPipePosition"));
                                //排气管口朝向 （爬虫程序不存在）
                                environmentalInfoData.setExhaustpipeorientations((String) map.get("exhaustPipeOrientations"));
                                //共轨管型号/生产企业 （爬虫程序不存在）
                                environmentalInfoData.setGgxhscqy((String) map.get("ggxhScqy"));
                                //喷射泵或压力调节器型号/生产厂 （pressureRegulatorModel爬虫存在，没爬到？）
                                environmentalInfoData.setPressureRegulatorModel((String) map.get("pressureRegulatorModel"));
                                //燃油蒸发污染物排放控制装置型号/生产厂（fuelEmissionControl 爬虫存在，没爬到？）
                                environmentalInfoData.setFuelEmissionControl((String) map.get("fuelEmissionControl"));

                                //2021-10-08 新增
                                //额定功率/转速
                                environmentalInfoData.setRatedPowerSpeed((String) map.get("ratedPowerSpeed"));
                                //催化转化器（LNT）型号/生产企业
                                environmentalInfoData.setCatalystsTypeLNT((String) map.get("catalystsTypeLNT"));
                                //封装/载体/涂层生产企业（LNT）
                                environmentalInfoData.setTcZtFzLnt((String) map.get("tcZtFzLnt"));
                                // 颗粒捕集器（DPF）型号/生产企业
                                environmentalInfoData.setKlpjqDFF((String) map.get("klpjqDFF"));
                                // 封装/载体/涂层生产企业(颗粒捕集器（DPF）)
                                environmentalInfoData.setTcZtFzDFF((String) map.get("tcZtFzDFF"));

                                if (environmentalInfoData.getCarTypeCode() != null
                                        && !environmentalInfoData.getCarTypeCode().equals("")) {
                                    saveOrUpdate(environmentalInfoData);

                                    // 删除对应的检验信息，然后再进行保存
                                    deleteTypeInspectionInformation(environmentalInfoData.getId());

                                    @SuppressWarnings("unchecked")
                                    List<LinkedTreeMap<String, Object>> informations = (List<LinkedTreeMap<String, Object>>) map
                                            .get("emps");
                                    for (LinkedTreeMap<String, Object> linkedTreeMap : informations) {
//                                        TypeInspectionInformationEntity informationEntity = new TypeInspectionInformationEntity();
                                        SyxyInspectionInformationEO informationEntity = new SyxyInspectionInformationEO();
                                        informationEntity.setEnvironmentalId(environmentalInfoData.getId());
                                        informationEntity
                                                .setBasedOnStandard((String) linkedTreeMap.get("basedOnStandard"));
                                        informationEntity.setDetectionMechanism(
                                                (String) linkedTreeMap.get("detectionMechanism"));
                                        informationEntity
                                                .setTestConclusion((String) linkedTreeMap.get("testConclusion"));
                                        String orderNumber = String.valueOf(linkedTreeMap.get("orderNumber"));
                                        if (StringUtils.isNotEmpty(orderNumber)) {
                                            Double d = Double.parseDouble(orderNumber);
                                            BigDecimal.valueOf(d);
                                            informationEntity.setOrderNumber(BigDecimal.valueOf(d));
                                        }
                                        //save(informationEntity);
                                        inspectionInformationEOService.save(informationEntity);
                                    }
                                }
                            }
                        } catch (ConstraintViolationException e) {
                            System.err.println("数据已存在");
                            continue;
                        }
                    }
                }
            } catch (Exception e) {
                addEnvSyncPC(Integer.parseInt(pc), "", qyid, "3");
                e.printStackTrace();
                if (e.getCause() != null) {
                    if (e.getCause().getMessage().equals("Connection refused: connect")) {
                        return false;
                    }
                }
                e.printStackTrace();
            }
        }
        return true;
    }

    // 删除对应的检验信息
    public void deleteTypeInspectionInformation(String environmentalId) {
//        StringBuilder sql=new StringBuilder();
//        sql.append("delete from SYXY_INSPECTION_INFORMATION where ENVIRONMENTAL_ID = ?");
//        jdbcTemplate.update(sql.toString(),new Object[]{environmentalId});
//          envInfoDao.deleteTypeInspectionInformation(environmentalId);
//        SyxyInspectionInformationEO eo = new SyxyInspectionInformationEO();
//         eo.setEnvironmentalId(environmentalId);
        QueryWrapper<SyxyInspectionInformationEO> queryMtModelWrapper = new QueryWrapper<>();
        queryMtModelWrapper.eq(SyxyInspectionInformationEO.SYXY_INSPECTION_INFORMATION_ENVIRONMENTAL_ID, environmentalId);
        inspectionInformationEOService.remove(queryMtModelWrapper);
    }


    // 新增环保已同步的批次
    private void addEnvSyncPC(int pc, String qymc, String qyid, String status) {
        // List<SyxyEnvSyncRecordEO> envSyncRecords = systemService.loadAll(EnvSyncRecordEntity.class);
        SyxyEnvSyncRecordEO syxyEnvSyncRecordEO = new SyxyEnvSyncRecordEO();
        syxyEnvSyncRecordEO.setId(UUID.randomUUID().toString());
        syxyEnvSyncRecordEO.setPc(BigDecimal.valueOf(pc));
        syxyEnvSyncRecordEO.setQymc(qymc);
        syxyEnvSyncRecordEO.setQyid(qyid);
        syxyEnvSyncRecordEO.setStatus(status); //0:表示开始执行  1:表示执行结束 3：表示执行异常
//        iSyxyEnvSyncRecordEOService.save(syxyEnvSyncRecordEO);
        iSyxyEnvSyncRecordEOService.saveOrUpdate(syxyEnvSyncRecordEO);
    }

    // 更新环保已同步的批次
    private void updateEnvSyncPC(int pc, String qymc, String qyid, String status) {
        QueryWrapper<SyxyEnvSyncRecordEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(SyxyEnvSyncRecordEO.SYXY_ENV_SYNC_RECORD_QYID, qyid)
                .eq(SyxyEnvSyncRecordEO.SYXY_ENV_SYNC_RECORD_PC, pc);
        List<SyxyEnvSyncRecordEO> list = iSyxyEnvSyncRecordEOService.list(queryWrapper);
        if (list.size() > 0) {
            SyxyEnvSyncRecordEO syxyEnvSyncRecordEO = list.get(0);
            syxyEnvSyncRecordEO.setStatus(status);//0:表示开始执行  1:表示执行结束 3：表示执行异常
            iSyxyEnvSyncRecordEOService.saveOrUpdate(syxyEnvSyncRecordEO);
        }
    }

    // 获取合格证pc
    private int getNoticeRecordPC() {
//        List<CertNoticeRecordEntity> certNoticeRecords = systemService.loadAll(CertNoticeRecordEntity.class);
//        if (certNoticeRecords != null && !certNoticeRecords.isEmpty()) {
//            return certNoticeRecords.get(0).getPc();
//        } else {
//            throw new UnsupportedOperationException("数据不存在");
//        }
        return 335;
    }


    // 获取环保pc
    private int getEnvRecordPC() {
        //TODO
//        List<EnvSyncRecordEntity> envSyncRecords = systemService.loadAll(EnvSyncRecordEntity.class);
//        if (envSyncRecords != null && !envSyncRecords.isEmpty()) {
//            return envSyncRecords.get(0).getPc();
//        } else {
//            throw new UnsupportedOperationException("数据不存在");
//        }
        return 333;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String importHbqdData(List<HbqdTemplateInfoVo> templateInfoVos, String qyId, String name) {
        // Vin编号是否重复
        Set<String> hbCertnoList = templateInfoVos.stream().map(HbqdTemplateInfoVo::getHbCertno).collect(Collectors.toSet());
        Set<String> vinList = templateInfoVos.stream().map(HbqdTemplateInfoVo::getVin).collect(Collectors.toSet());
        if (vinList.size() != templateInfoVos.size()) {
            throw new BusinessException("车辆识别码重复：");
        }

        // 校验环保信息公开编号是否存在
        List<SyxyEnvironmentalDataEO> syxyEnvironmentalDataEOList = environmentalDataEOService.lambdaQuery().in(SyxyEnvironmentalDataEO::getInfoDisclosureNo, hbCertnoList).list();
        List<String> existHbCertnoList = syxyEnvironmentalDataEOList.stream().map(SyxyEnvironmentalDataEO::getInfoDisclosureNo).collect(Collectors.toList());
        List<String> notExistHbCertnoList = hbCertnoList.stream().filter(x -> {
            return !existHbCertnoList.contains(x);
        }).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(notExistHbCertnoList)) {
            throw new BusinessException("环保信息公开编号在官方一致性数据中不存在：" + notExistHbCertnoList);
        }

        List<VehicleCertEO> vehicleCertEOS = vehicleCertEOService.lambdaQuery().eq(VehicleCertEO::getQyId, qyId).in(VehicleCertEO::getVin, vinList).list();
        Map<String, VehicleCertEO> vehicleCertEOVinMap = vehicleCertEOS.stream().collect(Collectors.toMap(VehicleCertEO::getVin, VehicleCertEO -> VehicleCertEO));

        List<String> vinNoList = vehicleCertEOS.stream().filter(x -> StringUtil.isNotEmpty(x.getHbCertno())).map(VehicleCertEO::getVin).collect(Collectors.toList());
        Map<String, SyxyModelEnviromentalDataEO> modelEnviromentalDataEOMap = CollectionUtils.isEmpty(vinNoList) ? new HashMap<>() : modelEnviromentalDataEOService.lambdaQuery().in(SyxyModelEnviromentalDataEO::getVin, vinNoList).list().stream().collect(Collectors.toMap(SyxyModelEnviromentalDataEO::getVin, SyxyModelEnviromentalDataEO -> SyxyModelEnviromentalDataEO));

        List<VehicleCertEO> vehicleCertEOList = new ArrayList<>();
        Date sysDate = new Date();
        List<String> confirmVinNoList = new ArrayList<>();
        StringBuilder hbCertnMsg = new StringBuilder();
        for (HbqdTemplateInfoVo templateInfoVo : templateInfoVos) {
            VehicleCertEO vehicleCertEO = vehicleCertEOVinMap.get(templateInfoVo.getVin());
            if (vehicleCertEO == null) {
                vehicleCertEO = new VehicleCertEO();
                vehicleCertEO.setId(UUID.randomUUID())
                        .setQyId(qyId)
                        .setVin(templateInfoVo.getVin())
                        .setCreateTime(sysDate);
            } else {
                SyxyModelEnviromentalDataEO modelEnviromentalDataEO = modelEnviromentalDataEOMap.get(vehicleCertEO.getVin());
                // 已确认的VIN编号不处理并提示
                if (modelEnviromentalDataEO != null && ConfirmStatus.CONFIRMED.getValue().equals(modelEnviromentalDataEO.getConfirmStatus())) {
                    confirmVinNoList.add(vehicleCertEO.getVin());
                    continue;
                }
                // 导入前后环保信息公开编号不一致的给出提示
                if (!templateInfoVo.getHbCertno().equals(vehicleCertEO.getHbCertno())) {
                    hbCertnMsg.append("{车辆识别码：").append(vehicleCertEO.getVin()).append("，导入前环保信息公开编号：").append(vehicleCertEO.getHbCertno())
                            .append("，导入后环保信息公开编号：").append(templateInfoVo.getHbCertno()).append("}，");
                }
            }
            vehicleCertEO.setHbCertno(templateInfoVo.getHbCertno())
                    .setFdjNo(templateInfoVo.getFdjNo())
                    .setProduceDate(templateInfoVo.getProduceDate())
                    .setUpdateTime(sysDate);
            vehicleCertEOList.add(vehicleCertEO);
        }
        if (CollectionUtils.isNotEmpty(vehicleCertEOList)) {
            vehicleCertEOService.saveOrUpdateBatch(vehicleCertEOList);
        }
        StringBuilder okMsg = new StringBuilder();
        okMsg.append("导入完成。");
        if (CollectionUtils.isNotEmpty(confirmVinNoList)) {
            okMsg.append("已确认的车辆识别码信息无法修改：").append(confirmVinNoList).append("。");
        }
        if (hbCertnMsg.length() > 0) {
            okMsg.append("导入前后环保信息公开编号不一致（已覆盖）：[").append(hbCertnMsg.deleteCharAt(hbCertnMsg.length() - 1)).append("]。");
        }
        return okMsg.toString();
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public String importNewHbqdData(List<HbqdTemplateInfoVo> templateInfoVos, String qyId, String name) {
        // Vin编号是否重复
        Set<String> hbCertnoList = templateInfoVos.stream().map(HbqdTemplateInfoVo::getHbCertno).collect(Collectors.toSet());
        Set<String> vinList = templateInfoVos.stream().map(HbqdTemplateInfoVo::getVin).collect(Collectors.toSet());
        if (vinList.size() != templateInfoVos.size()) {
            throw new BusinessException("车辆识别码重复：");
        }

        // 校验环保信息公开编号是否存在
        List<SyxyEnvironmentalDataEO> syxyEnvironmentalDataEOList = environmentalDataEOService.lambdaQuery().in(SyxyEnvironmentalDataEO::getInfoDisclosureNo, hbCertnoList).list();
        List<String> existHbCertnoList = syxyEnvironmentalDataEOList.stream().map(SyxyEnvironmentalDataEO::getInfoDisclosureNo).collect(Collectors.toList());
        List<String> notExistHbCertnoList = hbCertnoList.stream().filter(x -> {
            return !existHbCertnoList.contains(x);
        }).collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(notExistHbCertnoList)) {
            throw new BusinessException("环保信息公开编号在官方一致性数据中不存在：" + notExistHbCertnoList);
        }

        List<VehicleCertEO> vehicleCertEOS = vehicleCertEOService.lambdaQuery().eq(VehicleCertEO::getQyId, qyId).in(VehicleCertEO::getVin, vinList).list();
        Map<String, VehicleCertEO> vehicleCertEOVinMap = vehicleCertEOS.stream().collect(Collectors.toMap(VehicleCertEO::getVin, VehicleCertEO -> VehicleCertEO));

        List<String> vinNoList = vehicleCertEOS.stream().filter(x -> StringUtil.isNotEmpty(x.getHbCertno())).map(VehicleCertEO::getVin).collect(Collectors.toList());
        Map<String, SyxyModelEnviromentalDataEO> modelEnviromentalDataEOMap = CollectionUtils.isEmpty(vinNoList) ? new HashMap<>() : modelEnviromentalDataEOService.lambdaQuery().in(SyxyModelEnviromentalDataEO::getVin, vinNoList).list().stream().collect(Collectors.toMap(SyxyModelEnviromentalDataEO::getVin, SyxyModelEnviromentalDataEO -> SyxyModelEnviromentalDataEO));

        List<VehicleCertEO> vehicleCertEOList = new ArrayList<>();
        Date sysDate = new Date();
        List<String> confirmVinNoList = new ArrayList<>();
        StringBuilder hbCertnMsg = new StringBuilder();

        for (HbqdTemplateInfoVo templateInfoVo : templateInfoVos) {
            //新增校验--校验该Vin 对应的环保数据是否已经申报
            String vin = templateInfoVo.getVin();                  // vin
            String fdjNo = templateInfoVo.getFdjNo();             //发动机编号
            Date produceDate = templateInfoVo.getProduceDate();  //制造日期

            //找已存在vin中发动机等信息不能记录的集合，返回给前端！！
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            String formatProduceDate = sdf.format(produceDate);

            QueryWrapper<VehicleCertEO> queryWrapperVinInfo = new QueryWrapper<>();
            queryWrapperVinInfo.eq(VehicleCertEO.VEHICLE_CERT_VIN, templateInfoVo.getVin());
            List<VehicleCertEO> listVinInfo = vehicleCertEOService.list(queryWrapperVinInfo);
            if (listVinInfo.size() > 0) {
                VehicleCertEO vehicleCertEO = listVinInfo.get(0);
                String fdjNo1 = vehicleCertEO.getFdjNo();
                Date produceDate1 = vehicleCertEO.getProduceDate();
                String formatProduceDate1 = sdf.format(produceDate1);
                if (!fdjNo.equals(fdjNo1) || !formatProduceDate.equals(formatProduceDate1)) {
                    //进行覆盖操作，同时覆盖三个模块相关表的操作！！
                    syncEnvHgzYzxData(vin, fdjNo, produceDate, null);
                }
            } else {
                //做新增操作即可！！
                VehicleCertEO vehicleCertEO = new VehicleCertEO();
                vehicleCertEO = new VehicleCertEO();
                vehicleCertEO.setId(UUID.randomUUID())
                        .setQyId(qyId)
                        .setVin(templateInfoVo.getVin())
                        .setCreateTime(sysDate)
                        .setHbCertno(templateInfoVo.getHbCertno())
                        .setFdjNo(templateInfoVo.getFdjNo())
                        .setProduceDate(templateInfoVo.getProduceDate());

                vehicleCertEOList.add(vehicleCertEO);
            }
        }
        if (CollectionUtils.isNotEmpty(vehicleCertEOList)) {
            vehicleCertEOService.saveOrUpdateBatch(vehicleCertEOList);
        }

        StringBuilder okMsg = new StringBuilder();
        okMsg.append("导入完成!");
        if (CollectionUtils.isNotEmpty(confirmVinNoList)) {
            okMsg.append("已确认的车辆识别码信息无法修改：").append(confirmVinNoList).append("。");
        }
        if (hbCertnMsg.length() > 0) {
            okMsg.append("导入前后环保信息公开编号不一致（已覆盖）：[").append(hbCertnMsg.deleteCharAt(hbCertnMsg.length() - 1)).append("]。");
        }
        return okMsg.toString();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String syncEnvHgzYzxData(String vin, String fdjNo, Date produceDate, String vehicleColor) {
        try {
            //同步 NERDS.VEHICLE_CERT 等表中 【发动机编号】、【制造日期】、【车身颜色】等字段数据的一致性
            QueryWrapper<VehicleCertEO> queryVehicleCertEOWrapper = new QueryWrapper<>();
            queryVehicleCertEOWrapper.eq(VehicleCertEO.VEHICLE_CERT_VIN, vin);
            VehicleCertEO vehicleCertEO = vehicleCertEOService.getOne(queryVehicleCertEOWrapper);
            if (null != fdjNo && !"".equals(fdjNo) && !"null".equals(fdjNo)) {
                vehicleCertEO.setFdjNo(fdjNo);
            }
            if (null != produceDate) {
                vehicleCertEO.setProduceDate(produceDate);
            }
            if (null != vehicleColor && !"".equals(vehicleColor) && !"null".equals(vehicleColor)) {
                vehicleCertEO.setVehicleColor(vehicleColor);
            }
            vehicleCertEOService.saveOrUpdate(vehicleCertEO);

            //同步环保数据表中的 【发动机编号】、【制造日期】 等字段数据的一致性
            QueryWrapper<SyxyModelEnviromentalDataEO> queryHbWrapper = new QueryWrapper<>();
            queryHbWrapper.eq(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN, vin);
            List<SyxyModelEnviromentalDataEO> hblist = modelEnviromentalDataEOService.list(queryHbWrapper);
            if (hblist.size() > 0) {
                SyxyModelEnviromentalDataEO modelEnviromentalDataEO = hblist.get(0);
                if (null != fdjNo && !"".equals(fdjNo) && !"null".equals(fdjNo)) {
                    modelEnviromentalDataEO.setFdjNo(fdjNo);
                }
                if (null != produceDate) {
                    modelEnviromentalDataEO.setProduceDate(produceDate);
                }
                modelEnviromentalDataEOService.saveOrUpdate(modelEnviromentalDataEO);
            }
            //同步一致性数据表中的 【发动机编号】、【制造日期】、【车身颜色】 等字段数据的一致性 （制造日期、车身颜色仅保存在Vehicle_Cert表中）
            //先根据vin查VEHICLE_CERT_VIN对应的ID
            QueryWrapper<VehicleCertEO> querWrapperyzxID = new QueryWrapper<>();
            querWrapperyzxID.eq(VehicleCertEO.VEHICLE_CERT_VIN, vin);
            String yzxid = vehicleCertEOService.getOne(querWrapperyzxID).getId();
            //根据ID查询申报状态
            QueryWrapper<YzxTemplateDataEO> queryYzWrapper = new QueryWrapper<>();
            queryYzWrapper.eq(YzxTemplateDataEO.ID, yzxid);
            List<YzxTemplateDataEO> yzlist = yzxTemplateDataEOService.list(queryYzWrapper);
            if (yzlist.size() > 0) {
                YzxTemplateDataEO yzxTemplateDataEO = yzlist.get(0);
                if (null != fdjNo && !"".equals(fdjNo) && !"null".equals(fdjNo)) {
                    yzxTemplateDataEO.setDriveNo(fdjNo);
                }
                yzxTemplateDataEOService.saveOrUpdate(yzxTemplateDataEO);
            }
            //TODO 同步合格证表中的 【发动机编号】、【制造日期】、【车身颜色】 等字段数据的一致性 (钱工)

            UpdateWrapper<CertHgzPrintEO> updateWrapperHgz = new UpdateWrapper<>();
            SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd");
            if (produceDate != null) {
                updateWrapperHgz.set(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_CLZZRQ, fmt.format(produceDate));
            }
            if (StringUtils.isNotEmpty(fdjNo)) {
                updateWrapperHgz.set(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_FDJH, fdjNo);
            }
            if (StringUtils.isNotEmpty(vehicleColor)) {
                updateWrapperHgz.set(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_CSYS, vehicleColor);
            }
            updateWrapperHgz.eq(CertHgzPrintEO.CERT_HGZ_PRINT_VEH_CLSBDH, vin);
            certHgzPrintEOService.update(updateWrapperHgz);
        } catch (Exception e) {
            return e.getMessage();
        }
        return "success";
    }


    @Override
    public SyxyEnvironmentAllInfo getEnvironmentAllInfoById(Serializable id) {
        SyxyEnvironmentAllInfo syxyEnvironmentAllInfo = new SyxyEnvironmentAllInfo();
        SyxyEnvironmentalDataEO byId = environmentalDataEOService.getById(id);
        // 查找对应的检验信息
        // 根据对应的环保信息公开基础数据的id找到对应的型式检验信息
        // String sql="select * from syxy_inspection_information where ENVIRONMENTAL_ID =? order by ORDER_NUMBER";
        QueryWrapper<SyxyInspectionInformationEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(SyxyInspectionInformationEO.SYXY_INSPECTION_INFORMATION_ENVIRONMENTAL_ID, id);
        List<SyxyInspectionInformationEO> list = inspectionInformationEOService.list(queryWrapper);

        syxyEnvironmentAllInfo.setEnvironmentalDataEO(byId);
        syxyEnvironmentAllInfo.setInspectionInformationList(list);

        return syxyEnvironmentAllInfo;
    }

    @Override
    public SyxyEnvironmentAllInfo updateEnvInfo(SyxyEnvironmentAllInfo data) {
        SyxyEnvironmentalDataEO environmentalDataEO = data.getEnvironmentalDataEO();
        saveOrUpdate(environmentalDataEO);
        List<SyxyInspectionInformationEO> inspectionInformationList = data.getInspectionInformationList();
        for (SyxyInspectionInformationEO inspectionInformationEO : inspectionInformationList) {
            inspectionInformationEOService.saveOrUpdate(inspectionInformationEO);
        }
        return data;
    }
}
