package com.adc.da.vdaims.service.impl;

import com.adc.da.mp.base.Query;
//import com.adc.da.pdf.ConvertToPdfUtil;
import com.adc.da.vdaims.entity.*;
import com.adc.da.vdaims.dao.SyxyModelEnviromentalDataEODao;
import com.adc.da.vdaims.service.*;
import com.adc.da.vdaims.util.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.*;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.*;
import com.spire.doc.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * <p>
 *  服务实现类
 * </p>
 * 作者 gen
 * 日期 2021-08-30
 */
@Service
public class SyxyModelEnviromentalDataEOServiceImpl extends ServiceImpl<SyxyModelEnviromentalDataEODao, SyxyModelEnviromentalDataEO> implements ISyxyModelEnviromentalDataEOService {
    @Autowired
    private SyxyModelEnviromentalDataEODao enviromentalDataEODao;
    @Autowired
    private ISyxyEnviromentPrintTemplateEOService printTemplateEOService;
    @Autowired
    private ISyxyPrintEnterprisEOService printEnterprisEOService;
    @Autowired
    private ISyxyInspectionInformationEOService inspectionInformationEOService;
    @Autowired
    private ISyxyAccountSetEOService iSyxyAccountSetEOService;
    @Value("${qr.wordToPdfUrl}")
    private String wordToPdfUrl;
    @Override
    public List<SyxyModelEnviromentalDataEO> modelEnviromentalList(Query<SyxyModelEnviromentalDataEO> query) {
        // 先将符合条件的数据插入到数据表中
        try {
         enviromentalDataEODao.insertModelEnviromental();
        } catch (Exception e){
            e.printStackTrace();
        }
        return list(query);
    }

    @Override
    public IPage<SyxyModelEnviromentalDataEO> modelEnviromentpage(Query<SyxyModelEnviromentalDataEO> query) {
        // 先将符合条件的数据插入到数据表中
        try {
            enviromentalDataEODao.insertModelEnviromental();
        } catch (Exception e){
            e.printStackTrace();
        }
        return page(query);
    }

    @Override
    //根据车型款式找到选择的与环保随车信息相对应的docx模板
    public String getTemplatePath(String templateType, int templateKind) {
        String template = null;

//        CriteriaQuery cq = new CriteriaQuery(EnvironmentalPrintTemplateEntity.class);
//        cq.add(Restrictions.eq("templateName", templateName));
//        cq.add(Restrictions.eq("templateKind", templateKind));
//        List<EnvironmentalPrintTemplateEntity> list = getListByCriteriaQuery(cq, false);
//        if (list.size() != 0) {
//            template = list.get(0).getAttachment();
//        }
        QueryWrapper<SyxyEnviromentPrintTemplateEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(SyxyEnviromentPrintTemplateEO.SYXY_ENVIROMENT_PRINT_TEMPLATE_TEMPLATE_TYPE,templateType)
                .eq(SyxyEnviromentPrintTemplateEO.SYXY_ENVIROMENT_PRINT_TEMPLATE_TEMPLATE_KIND,templateKind);

        List<SyxyEnviromentPrintTemplateEO> list = printTemplateEOService.list(queryWrapper);
        if (list.size() != 0) {
            template = list.get(0).getAttachment();
        }
        return template;
    }

    // 生成国六二维码
    @Override
    public void createQRCodeSIX(String vin) {
        String text = Website.WEBSITE + vin; // 二维码内容
//        int width = 90; // 二维码图片宽度
//        int height = 90; // 二维码图片高度
        int width = 60; // 二维码图片宽度
        int height = 60; // 二维码图片高度
        String format = "png";// 二维码的图片格式
        PropertiesUtil p = new PropertiesUtil("sysConfig.properties");
        String path = p.readProperty("QRCodePath");
        String savePath = path + vin + ".png";
        GoogleQRCodeUtil.createQRCode(text, width, height, format, savePath);
    }

    @Override
    public void createBarCodeSix(String vin) {
        //String V = "VIN:"+vin;
        PropertiesUtil p = new PropertiesUtil("sysConfig.properties");
        String savePath = p.readProperty("barcodePath");
        BarcodeUtil.generateFileS(vin, savePath, vin);
    }

    @Override
    public void createQRCode(String vin) {
        String text = Website.WEBSITE + vin; // 二维码内容
        PropertiesUtil p = new PropertiesUtil("sysConfig.properties");
        String path = p.readProperty("QRCodePath");
        String file =vin + ".png";
        try {
            QRCodeUtil.encode(text, null, path,file, true);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void createBarCode(String vin) {
        PropertiesUtil p = new PropertiesUtil("sysConfig.properties");
        String savePath = p.readProperty("barcodePath");
        BarcodeUtil.generateFile(vin, savePath, vin);
    }

    @Override
    public String createWord(final SyxyModelEnviromentalDataEO environmentalPrint,
                             final SyxyModelEnviromentalDataEO environmentalInfoData,
                             final List<SyxyInspectionInformationEO> informations,
                             final String templatePath,
                             final Integer previewFlag,String qyname,String qyId,String printType) throws UnsupportedEncodingException, FileNotFoundException, IOException
    {
        String message = "";
        try {

            List<Map<String, String>> list = new ArrayList<Map<String, String>>();
            PropertiesUtil p = new PropertiesUtil("sysConfig.properties");
            String realpath = p.readProperty("realpath");
            String fileName = templatePath.substring(0, templatePath.indexOf("|"));
            WordprocessingMLPackage template = Docx4jUtil.getTemplate(realpath + fileName);
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getVehicleDesign() == null ? "" : environmentalInfoData.getVehicleDesign(),
                    "${vehicleDesign}"); // 适用车型 （目前模板中不存在）

            Docx4jUtil.replacePlaceholder(template,
                    environmentalPrint.getInfoDisclosureNo() == null ? "" : environmentalPrint.getInfoDisclosureNo(),
                    "${infoDisclosureNo}"); // 信息公开编号
            Docx4jUtil.replacePlaceholder(template,
                    environmentalPrint.getVin() == null ? "" : environmentalPrint.getVin(),
                    "${vin}"); // vin
//            Docx4jUtil.replacePlaceholder(template, environmentalPrint.getCarType() == null ? "" : environmentalPrint.getCarType(),
//                    "${carType}"); // 车辆型号

            Docx4jUtil.replacePlaceholder(template, qyname == null ? "" : qyname,
                    "${qyname}");

//            Docx4jUtil.replacePlaceholder(template, environmentalPrint.getExt2() == null ? "" : environmentalPrint.getExt2(),
//                    "${ext2}"); // 0 企业信息  ext2

            Docx4jUtil.replacePlaceholder(template, environmentalPrint.getTemplateInfo() == null ? "" : environmentalPrint.getTemplateInfo(),
                    "${ext2}"); // 0 企业信息  ext2


            Docx4jUtil.replacePlaceholder(template, environmentalPrint.getCarTypeCode() == null ? "" : environmentalPrint.getCarTypeCode(),
                    "${carModelType}"); // 1 车辆型号  // carType

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getTrademark() == null ? "" : environmentalInfoData.getTrademark(), "${trademark}"); // 2 商标
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCarCategory() == null ? "" : environmentalInfoData.getCarCategory(), "${carCategory}"); // 3 汽车分类
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getDischargeStage() == null ? "" : environmentalInfoData.getDischargeStage(),
                    "${dischargeStage}"); // 4排放阶段
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCarIdentLocation() == null ? "" : environmentalInfoData.getCarIdentLocation(),
                    "${carIdentLocation}"); // 5车型的识别方法和位置
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCarConstructName() == null ? "" : environmentalInfoData.getCarConstructName(),
                    "${carConstructName}"); // 6车辆制造商名称

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getFactoryAddress() == null ? "" : environmentalInfoData.getFactoryAddress(),
                    "${factoryAddress}"); // 7生产厂地址

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEngineType() == null ? "" : environmentalInfoData.getEngineType(), "${engineType}"); // 8 发动机型号
            //第二部分发动机信息
//            Docx4jUtil.replacePlaceholder(template,
//                    environmentalPrint.getEngineNumber() == null ? "" : environmentalPrint.getEngineNumber(), "${engineNumber}"); // 发动机号（发动机编号）

            Docx4jUtil.replacePlaceholder(template,
                    environmentalPrint.getEngineNo() == null ? "" : environmentalPrint.getEngineNo(), "${engineNumber}"); // 9 发动机号（发动机编号）

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEngineConstructName() == null ? "" : environmentalInfoData.getEngineConstructName(),
                    "${engineConstructName}"); // 10 制造商名称
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEngineFamilyName() == null ? "" : environmentalInfoData.getEngineFamilyName(),
                    "${engineFamilyName}"); // 11 系族名称
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEngineFactoryAddress() == null ? "" : environmentalInfoData.getEngineFactoryAddress(),
                    "${engineFactoryAddress}"); //12 生产厂地址
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEngineMake() == null ? "" : environmentalInfoData.getEngineMake(), "${engineMake}"); // 13 厂牌


            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getCcsy() == null ? "" : environmentalInfoData.getCcsy().equals("双怠速试验")? "GB 18285" : environmentalInfoData.getCcsy() ,"${ccsy}"); // 15-1出厂检验项目
            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getCcjl() == null ? "" : environmentalInfoData.getCcjl() ,"${ccjl}"); // 15-2 出厂检验结果


            //第四部分污染控制技术
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getMaximumNetPower() == null ? "" : environmentalInfoData.getMaximumNetPower(), "${maximumNetPower}"); // 17 最大净功率/转速（kW/r/min）
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getMaximumNetTorque() == null ? "" : environmentalInfoData.getMaximumNetTorque(), "${maximumNetTorque}"); // 18 最大净扭矩/转速（Nm/r/min）
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getFuelSupplySystemType() == null ? "" : environmentalInfoData.getFuelSupplySystemType(), "${fuelSupplySystemType}"); // 19 燃料供给系统型式

//                    Docx4jUtil.replacePlaceholder(template,
//                    environmentalInfoData.getInjectionPumpModel() == null ? "" : environmentalInfoData.getInjectionPumpModel(),
//                    "${injectionPumpModel}"); // 喷油泵型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getInjectionPumpMoedl() == null ? "" : environmentalInfoData.getInjectionPumpMoedl(),
                    "${injectionPumpModel}"); // 20 喷油泵型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getInjectorModel() == null ? "" : environmentalInfoData.getInjectorModel(),
                    "${injectorModel}"); // 21 喷油器型号/生产厂

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getSuperchargerModel() == null ? "" : environmentalInfoData.getSuperchargerModel(),
                    "${superchargerModel}"); // 22 增压器型号/生产厂

            //            Docx4jUtil.replacePlaceholder(template,
//                    environmentalInfoData.getHeartShapeType() == null ? "" : environmentalInfoData.getHeartShapeType(),
//                    "${heartShapeType}"); // 中冷器型式

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getHeartshapetype() == null ? "" : environmentalInfoData.getHeartshapetype(),
                    "${heartShapeType}"); // 23 中冷器型式

            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getObdType() == null ? "" : environmentalInfoData.getObdType(),
                    "${obdType}"); // 24 OBD型号/生产厂

            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getErgType() == null ? "" : environmentalInfoData.getErgType(),
                    "${ergType}"); // 25 EGR型号/生产厂


            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEcuModelVersionNum() == null ? "" : environmentalInfoData.getEcuModelVersionNum(),
                    "${ecuModelVersionNum}"); // 26 ECU型号/版本号/生产厂

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getExhaustPostSystemModel() == null ? "" : environmentalInfoData.getExhaustPostSystemModel(), "${exhaustPostSystemModel}"); // 27-1 排气后处理系统型号/生产厂

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getPackagCarrierCoating() == null ? "" : environmentalInfoData.getPackagCarrierCoating(),
                    "${packagCarrierCoating}"); // 27-2 涂层/载体/封装生产厂


            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getExhaustPostSystemType() == null ? "" : environmentalInfoData.getExhaustPostSystemType(), "${exhaustPostSystemType}"); //28 排气后处理系统型式

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getAirFilterModel() == null ? "" : environmentalInfoData.getAirFilterModel(), "${airFilterModel}"); // 29 空气滤清器型号/生产厂

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getIntakeMufflerModel() == null ? "" : environmentalInfoData.getIntakeMufflerModel(), "${intakeMufflerModel}"); // 30 进气消声器型号/生产厂


            //            Docx4jUtil.replacePlaceholder(template,
//                    environmentalInfoData.getExHaustMufflerModel()== null ? "" : environmentalInfoData.getExHaustMufflerModel(), "${exHaustMufflerModel}"); // 排气消声器型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getExhaustMufflerModel()== null ? "" : environmentalInfoData.getExhaustMufflerModel(), "${exHaustMufflerModel}"); // 31 排气消声器型号/生产厂



            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getLegalRepresentative() == null ? "" : environmentalInfoData.getLegalRepresentative(),
                    "${legalRepresentative}"); // 32 法人代表
            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getAddress() == null ? "" : environmentalInfoData.getAddress(),
                    "${address}"); // 33 地址
            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getMobile() == null ? "" : environmentalInfoData.getMobile(),
                    "${mobile}"); // 34 联系电话


            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEnterpriseInfoPublicUrl() == null ? "" : environmentalInfoData.getEnterpriseInfoPublicUrl(),
                    "${enterpriseInfoPublicUrl}"); // 企业信息公开网址  // ${website}

//            Docx4jUtil.replacePlaceholder(template, environmentalPrint.getProducedDate() == null ? new SimpleDateFormat("yyyy-MM-dd").format(new Date())
//             : DateUtils.getFromDate(environmentalPrint.getProducedDate(), true), "${producedDate}"); // 车辆制造日期
            Docx4jUtil.replacePlaceholder(template, environmentalPrint.getProducedDate() == null ? new SimpleDateFormat("yyyy-MM-dd").format(new Date())
                    : DateUtils.getFromDate(environmentalPrint.getProducedDate(), true), "${producedDate}"); // 车辆制造日期


            //-----------------------------------------------------------------------
            //电动车环保信息随车清单  新增
            // 01  生产企业  PRO_BUSINESS
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getProBusiness() == null ? "" : environmentalInfoData.getProBusiness(),
                    "${proBusiness}");

            // 02  电动机型号/生产厂  MOTOR_MODEL
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getMotorModel() == null ? "" : environmentalInfoData.getMotorModel(),
                    "${motorModel}"); // 电动机型号/生产厂
            // 03 整车控制器型号/版本号/生产厂
            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getVehModelVersionNum() == null ? ""
                    : environmentalInfoData.getVehModelVersionNum(), "${vehModelVersionNum}"); // 整车控制器型号/版本号/生产厂
            // 04 储能装置型号/生产厂
            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getEnergyStoringModel() == null ? ""
                    : environmentalInfoData.getEnergyStoringModel(), "${energyStoringModel}"); // 储能装置型号/生产厂
            // 05 电池容量/续航里程
            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getBatteryCapacity() == null ? ""
                    : environmentalInfoData.getBatteryCapacity(), "${batteryCapacity}"); // 电池容量/续航里程

            //轻柴国六模板  新增
            Docx4jUtil.replacePlaceholder(template,
            environmentalInfoData.getJzzl() == null ? "" : environmentalInfoData.getJzzl(), "${jzzl}"); // 基准质量
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCrankEmisControlType() == null ? "" : environmentalInfoData.getCrankEmisControlType(),
                    "${crankEmisControlType}"); // 曲轴箱排放控制装置型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getKlbjqxhScqy() == null ? "" : environmentalInfoData.getKlbjqxhScqy(), "${klbjqxhScqy}"); // 颗粒捕集器型号/生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getTcZtFzscc() == null ? "" : environmentalInfoData.getTcZtFzscc(), "${tcZtFzscc}"); // 涂层/载体/封装生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getMufflerModel() == null ? "" : environmentalInfoData.getMufflerModel(), "${mufflerModel}"); // 消声器型号/生产厂
//            Docx4jUtil.replacePlaceholder(template,
//                    environmentalInfoData.getGearboxTypeGearNum() == null ? "" : environmentalInfoData.getGearboxTypeGearNum(),
//                    "${gearboxTypeGearNum}"); // 变速器型式/档位数
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getGerboxTypeGearNum() == null ? "" : environmentalInfoData.getGerboxTypeGearNum(),
                    "${gearboxTypeGearNum}"); // 变速器型式/档位数

           //20210927 新增
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getObdinterfacelocation() == null ? "" : environmentalInfoData.getObdinterfacelocation(), "${obdIFPositon}"); //  OBD接口位置
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCatalyststypedoc() == null ? "" : environmentalInfoData.getCatalyststypedoc(), "${catalystsTypeDoc}"); //  催化转化器（DOC）型号/生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getTcztfzdoc() == null ? "" : environmentalInfoData.getTcztfzdoc(), "${packagCarrierCoatingDoc}"); //  封装/载体/涂层生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCatalyststypescr() == null ? "" : environmentalInfoData.getCatalyststypescr(), "${catalystsTypeScr}"); //  催化转化器（SCR）型号/生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getTcztfzscr() == null ? "" : environmentalInfoData.getTcztfzscr(), "${packagCarrierCoatingScr}"); //  封装/载体/涂层生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getNitrogenoxidestype() == null ? "" : environmentalInfoData.getNitrogenoxidestype(), "${noCatalyticReductionConverter}"); //  氮氧化物存储催化还原催化转化器型号/生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getTcztfznitrogenoxides() == null ? "" : environmentalInfoData.getTcztfznitrogenoxides(), "${packageCarrierCoatingNo}"); //  封装/载体/涂层生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCatalyststypeasc() == null ? "" : environmentalInfoData.getCatalyststypeasc(), "${catalystsTypeAsc}"); //  催化转化器（ASC）型号/生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getTcztfzasc() == null ? "" : environmentalInfoData.getTcztfzasc(), "${packagCarrierCoatingAsc}"); //  封装/载体/涂层生产企业

            //轻汽国六 模板
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCatalystsType() == null ? "" : environmentalInfoData.getCatalystsType(), "${catalystsType}"); // 催化器型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getTgxhScqy() == null ? "" : environmentalInfoData.getTgxhScqy(), "${tgxhScqy}"); // 炭罐型号/生产企业
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getOxygenSensorType() == null ? "" : environmentalInfoData.getOxygenSensorType(),
                    "${oxygenSensorType}"); // 氧传感器型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getSuperchargerModel() == null ? "" : environmentalInfoData.getSuperchargerModel(),
                    "${superchargerModel}"); // 增压器型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCoatCarrEncapsul() == null ? "" : environmentalInfoData.getCoatCarrEncapsul(),
                    "${coatCarrEncapsul}"); // 涂层/载体/封装生产企业

            //重柴国六
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getExhaustpipeposition() == null ? "" : environmentalInfoData.getExhaustpipeposition(),
                    "${exhaustPipePosition}"); // 排气管口位置
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getExhaustpipeorientations() == null ? "" : environmentalInfoData.getExhaustpipeorientations(),
                    "${exhaustPipeOrientations}"); //排气管口朝向
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getGgxhscqy() == null ? "" : environmentalInfoData.getGgxhscqy(),
                    "${ggxhScqy}"); //共轨管型号/生产企业

            //重汽国四
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEjectorModel() == null ? "" : environmentalInfoData.getEjectorModel(), "${ejectorModel}"); // 喷射器型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getCrankcaseEmissionControl() == null ? "" : environmentalInfoData.getCrankcaseEmissionControl(), "${crankcaseEmissionControl}"); // 曲轴箱污染物排放控制装置型号/生产厂

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getPressureRegulatorModel() == null ? "" : environmentalInfoData.getPressureRegulatorModel(),
                    "${pressureRegulatorModel}"); //喷射泵或压力调节器型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getFuelEmissionControl() == null ? "" : environmentalInfoData.getFuelEmissionControl(),
                    "${fuelEmissionControl}"); //燃油蒸发污染物排放控制装置型号/生产厂

            //重型燃气国六
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getEvaporatorModel() == null ? "" : environmentalInfoData.getEvaporatorModel(), "${evaporatorModel}"); //蒸发器或压力调节器型号/生产厂
            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getHybridModel() == null ? "" : environmentalInfoData.getHybridModel(), "${hybridModel}"); //混合装置型号/生产厂



//            Docx4jUtil.replacePlaceholder(template,
//                    environmentalInfoData.getxx() == null ? "" : environmentalInfoData.getxx(),
//                    "${xx}");
//            Docx4jUtil.replacePlaceholder(template,
//                    environmentalInfoData.getxx() == null ? "" : environmentalInfoData.getxx(),
//                    "${xx}");
//            Docx4jUtil.replacePlaceholder(template,
//                    environmentalInfoData.getxx() == null ? "" : environmentalInfoData.getxx(),
//                    "${xx}");

//TODO 模板中没有，暂时注释掉


/*





            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getProBusiness() == null ? "" : environmentalInfoData.getProBusiness(), "${proBusiness}"); // 生产企业






            //燃油车区别于燃气车字段

            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getCcsy() != null || environmentalInfoData.getCcjl() != null
                    ? environmentalInfoData.getCcsy() + "," + environmentalInfoData.getCcjl() : "", "${factoryInspectResult}"); // 出厂检验项目及结果
            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getCcsy() == null ? "" : environmentalInfoData.getCcsy() ,"${ccsyF}"); // 出厂检验项目
            Docx4jUtil.replacePlaceholder(template, environmentalInfoData.getCcjl() == null ? "" : environmentalInfoData.getCcjl() ,"${ccjlF}"); // 出厂检验结果

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getFuelEvaporaControlType() == null ? "" : environmentalInfoData.getFuelEvaporaControlType(),
                    "${fuelEvaporaControlType}"); // 燃油蒸发控制装置型号/生产厂

            Docx4jUtil.replacePlaceholder(template,
                    environmentalInfoData.getIuprMonitorFunction() == null ? "" : environmentalInfoData.getIuprMonitorFunction(),
                    "${iuprMonitorFunction}"); // IUPR监测功能
//





          */


//            for (TypeInspectionInformationEntity information : informations) {
//                Map<String, String> map = new HashMap<String, String>();
//                map.put("${stander}", information.getBasedOnStandard() == null ? "" : information.getBasedOnStandard());
//                map.put("${examineDepart}",
//                        information.getDetectionMechanism() == null ? "" : information.getDetectionMechanism());
//                map.put("${examinRes}", information.getTestConclusion() == null ? "" : information.getTestConclusion());
//                list.add(map);
//            }

            for (SyxyInspectionInformationEO information : informations) {
                Map<String, String> map = new HashMap<String, String>();
                map.put("${basedOnStandard}", information.getBasedOnStandard() == null ? "" : information.getBasedOnStandard());
                map.put("${detectionMechanism}",
                        information.getDetectionMechanism() == null ? "" : information.getDetectionMechanism());
                map.put("${testConclusion}", information.getTestConclusion() == null ? "" : information.getTestConclusion());
                list.add(map);
            }



            if (list.size() != 0) {
                Docx4jUtil.replaceTable(new String[] { "${basedOnStandard}", "${detectionMechanism}", "${testConclusion}" }, list,
                        template);
            } else {
                Docx4jUtil.replacePlaceholder(template, "", "${basedOnStandard}");
                Docx4jUtil.replacePlaceholder(template, "", "${detectionMechanism}");
                Docx4jUtil.replacePlaceholder(template, "", "${testConclusion}");
            }
            PropertiesUtil p1 = new PropertiesUtil("sysConfig.properties");
            String savePath = p1.readProperty("previewPath");

            //格式化当前日期
            Date d = new Date();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            //按企业和日期进行目录的分级
            savePath = savePath + qyId +"/env/" + sdf.format(d) + "/";
            // 替换成二维码
//            String codePath = p1.readProperty("QRCodePath") + environmentalPrint.getVehicleIdentificationNumber()
//                    + ".png";

            String codePath = p1.readProperty("QRCodePath") + environmentalPrint.getVin()
                    + ".png";


            File code = new File(codePath);
            String replace = "${qr}";
            if (code.exists()) {
                byte[] bytes = Docx4jUtil.convertImageToByteArray(code);
                Docx4jUtil.replaceImage(template, replace, bytes, "", "");
            } else {
                Docx4jUtil.replacePlaceholder(template, "图片损坏，请重新上传该条记录", replace);
            }
            // 替换成条形码
            String replace1 = "${image}";
//            String barcodePath = p1.readProperty("barcodePath") + environmentalPrint.getVehicleIdentificationNumber()
//                    + ".png";
            String barcodePath = p1.readProperty("barcodePath") + environmentalPrint.getVin()
                    + ".png";
            File code1 = new File(barcodePath);
            if (code1.exists()) {
                byte[] bytes1 = Docx4jUtil.convertImageToByteArray(code1);
                Docx4jUtil.replaceImage(template, replace1, bytes1, "", "");
            } else {
                Docx4jUtil.replacePlaceholder(template, "图片损坏，请重新上传该条记录", replace1);
            }

            // 制造商/进口企业信息
            /*
             * PropertiesUtil p2 = new PropertiesUtil("enterprise.properties");
             * String representative= p2.readProperty("representative");
             * Docx4jUtil.replacePlaceholder(template,representative,
             * "${representative}"); String address= p2.readProperty("address");
             * Docx4jUtil.replacePlaceholder(template, address, "${address}");
             * String phone=p2.readProperty("phone");
             * Docx4jUtil.replacePlaceholder(template, phone, "${phone}");
             * String website=p2.readProperty("website");
             * Docx4jUtil.replacePlaceholder(template, website , "${website}");
             */
            // 签章的替换
            /*
             * String replace2="${signature}"; String
             * signaturePath=this.getClass().getResource("/").getPath()+p2.
             * readProperty("signature")+"signature.png"; File signature= new
             * File(signaturePath); if(signature.exists()){ byte[] bytes2 =
             * Docx4jUtil.convertImageToByteArray(signature);
             * Docx4jUtil.replaceImage(template, replace2, bytes2, "","");
             * }else{ Docx4jUtil.replacePlaceholder(template,"签章已损坏", replace2);
             * }
             */

            // 预览文件保存路径
            File file = new File(savePath);
            if (!file.exists()) {
                file.mkdirs();
            }
//            String newName = "envData_" + environmentalPrint.getId() + ".docx";
            String newName ="";
            if("1".equals(printType)){
                newName = "envData_print_" + environmentalPrint.getId() + ".docx";
            }else if("2".equals(printType)){
                newName = "envData_upload_" + environmentalPrint.getId() + ".docx";
            }else{
                newName = "envData_print_" + environmentalPrint.getId() + ".docx";
            }

            Docx4jUtil.writeDocxToStream(template, savePath + newName);

            if (null != previewFlag) { // 预览或pdf报送要生成pdf
                String docxPath = savePath + newName;
               // String pdfPath = savePath + "envData_" + environmentalPrint.getId() + ".pdf";
                String pdfPath = "";
                if("1".equals(printType)){
                    pdfPath = savePath + "envData_print_" + environmentalPrint.getId() + ".pdf";
                }else if("2".equals(printType)){
                    pdfPath = savePath + "envData_upload_" + environmentalPrint.getId() + ".pdf";
                }else{
                    pdfPath = savePath + "envData_print_" + environmentalPrint.getId() + ".pdf";
                }

               // PDFUtils2.wordToPDF(docxPath, pdfPath);
                //TODO 环境问题，jar包冲突！！！！！！
              // ConvertToPdfUtil.convert2PDF(docxPath, pdfPath);
               // ConvertToPdfUtil.convert2PDF(docxPath, pdfPath);
                PDFUtils2.wordToPdf(new File(docxPath), new File(pdfPath), wordToPdfUrl);
            //C:/vdaims/template/envData_8830fcdff9f272f719535ce3d7ad8c24.docx
            //C:/vdaims/template/envData_8830fcdff9f272f719535ce3d7ad8c24.pdf

/*                Document document = new Document();
                document.loadFromFile(docxPath);
                //保存为PDF格式
                document.saveToFile(pdfPath, FileFormat.PDF);*/
                //message = pdfPath;
                if(previewFlag == 6 ){
                    message = pdfPath;
                }else{
                    message = docxPath;
                }
            }
        } catch (Exception e) {
            // e.printStackTrace();
            message = "模板创建异常，操作失败";
        }
        //对返回的文件路径进行截取处理
        //windows下
        if(null!=message && message.contains("C:")){
            message = message.replace("C:/vdaims/template/","");
        }
        if(null!=message && message.contains("D:")){
            message = message.replace("D:/vdaims/template/","");
        }
        if(null!=message && message.contains("c:")){
            message = message.replace("c:/vdaims/template/","");
        }
        if(null!=message && message.contains("d:")){
            message = message.replace("d:/vdaims/template/","");
        }
        //Linux下  阿里云
        if(null!=message && message.contains("/5")){
            message = message.replace("/5/vdaims/template/","");
        }
        // Linux下  中机服务器  root/ADCBS/1.0/vdaims/template
        if(null!=message && message.contains("/root")){
            message = message.replace("/root/ADCBS/1.0/vdaims/template","");
        }
        return message;

    }

    @Override
    public String findPrint() {
        //TODO 修改
//        List<AccountSetEntity> prints = loadAll(AccountSetEntity.class);
//        if (prints.size() == 0) {
//            return null;
//        } else {
//            return prints.get(0).getEPrink();
//        }
        return null;
    }

    @Override
    public void downFileWithfileName(String fileName, String pathName, HttpServletResponse response, HttpServletRequest request) {

        InputStream bis = null;
        BufferedOutputStream bos = null;
        String realpath = ResourceUtil.getConfigByName(pathName);
        String downpath = realpath + fileName;
        long fileLength = 0;
        try {
            bis = new BufferedInputStream(new FileInputStream(downpath));
            fileLength = new File(downpath).length();
        } catch (FileNotFoundException e1) {
            e1.printStackTrace();
        }
        try {
            String extend = FileUtils.getExtend(fileName);
            // 判断类型
            if (extend.equals("text")) {
                response.setContentType("text/plain;");
            } else if (extend.equals("doc") || extend.equals("docx")) {
                response.setContentType("application/msword;");
            } else if (extend.equals("xls")) {
                response.setContentType("application/ms-excel;");
            } else if (extend.equals("pdf")) {
                response.setContentType("application/pdf;");
            } else if (extend.equals("jpg") || extend.equals("jpeg")) {
                response.setContentType("image/jpeg;");
            } else {
                response.setContentType("application/x-msdownload;");
            }

            String userAgent = request.getHeader("user-agent").toLowerCase();
            if (userAgent.contains("mise") || userAgent.contains("like gecko")) {
                fileName = URLEncoder.encode(fileName, "UTF-8");
            } else {
                fileName = new String(fileName.getBytes(), "ISO-8859-1");
            }

            response.setHeader("Content-disposition", "attachment; filename=" + fileName);
            response.setHeader("Content-Length", String.valueOf(fileLength));
            bos = new BufferedOutputStream(response.getOutputStream());
            byte[] buff = new byte[2048];
            int bytesRead;
            while (-1 != (bytesRead = bis.read(buff, 0, buff.length))) {
                bos.write(buff, 0, bytesRead);
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (bis != null) {
                    bis.close();
                }
                if (bos != null) {
                    bos.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public SyxyModelEnviromentalDataEO updateEnviromentalData(SyxyModelEnviromentalDataEO data) {
        //设置打印状态为
        data.setPrintStatus("0"); //PrintStatus    0:未打印 1：参考打印 2：已经打印
        data.setConfirmStatus("0"); //  0:未确认 1：已确认
        //获取模板中的企业信息
        QueryWrapper<SyxyPrintEnterprisEO> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(SyxyPrintEnterprisEO.SYXY_PRINT_ENTERPRIS_QYMC,data.getProBusiness() == null ? "":data.getProBusiness()) // 生产企业
        .eq(SyxyPrintEnterprisEO.SYXY_PRINT_ENTERPRIS_TEMPLATENAME,data.getTemplateName()== null ? "":data.getTemplateName())   //模板名称
        .eq(SyxyPrintEnterprisEO.SYXY_PRINT_ENTERPRIS_TEMPLATETYPE, data.getExt3()== null ? "":data.getExt3());        //模板类别

        List<SyxyPrintEnterprisEO> list = printEnterprisEOService.list(queryWrapper);

        if(list.size()>0){
            data.setExt2(list.get(0).getInfo());   //模板企业信息
        }else{
            //如果未查到，则进行插入操作
            SyxyPrintEnterprisEO syxyPrintEnterprisEO = new SyxyPrintEnterprisEO();
            syxyPrintEnterprisEO.setId(UUID.randomUUID().toString());
            syxyPrintEnterprisEO.setCreatetime(new Date());
            syxyPrintEnterprisEO.setClxh(data.getCarModelType());         //车辆型号
            syxyPrintEnterprisEO.setTemplatename(data.getTemplateName()); //模板名称
            syxyPrintEnterprisEO.setTemplatetype(data.getExt3()) ; // 模板类型
            syxyPrintEnterprisEO.setInfo(data.getExt2()); // 模板企业信息
            syxyPrintEnterprisEO.setVin(data.getVin());  // vin

            printEnterprisEOService.save(syxyPrintEnterprisEO);
        }

        //updateById(data);
        saveOrUpdate(data);
        return data;
    }

    @Override
    public String doDeclarePdf(String vin,String qyid,String qyname) {
        String message = "";
        // 重新生成pdf进行报送
//        EnvironmentalDeclareEntity encft = getEntity(EnvironmentalDeclareEntity.class, id);
        SyxyModelEnviromentalDataEO encft= null;
        QueryWrapper<SyxyModelEnviromentalDataEO> queryWrapperOne = new QueryWrapper();
        queryWrapperOne.eq(SyxyModelEnviromentalDataEO.SYXY_MODEL_ENVIROMENTAL_DATA_VIN,vin);
        List<SyxyModelEnviromentalDataEO> listOne = list(queryWrapperOne);
        if(listOne.size() > 0){
            encft =listOne.get(0);
        }

//        /* 根据新增的车辆识别代号生成二维码 */
//        environmentalPrintService.createQRCode(encft.getDiscernNumber());
//        /* 根据新增的车辆识别代号生成条形码 */
//        environmentalPrintService.createBarCode(encft.getDiscernNumber());

/*        *//* 根据新增的车辆识别代号生成二维码 *//*
        createQRCode(encft.getVin());
        *//* 根据新增的车辆识别代号生成条形码 *//*
        createBarCode(encft.getVin());*/

        //判断国五还是国六
        if(encft.getDischargeStage() !=null && encft.getDischargeStage().equals("国六")) {
            /*根据新增的车辆识别代号生成二维码*/
//                                    environmentalPrintService.createQRCodeSIX(envPrintData.getVehicleIdentificationNumber());
            createQRCodeSIX(encft.getVin());

            /*根据新增的车辆识别代号生成条形码*/
//                                    environmentalPrintService.createBarCodeSix(envPrintData.getVehicleIdentificationNumber());
           createBarCodeSix(encft.getVin());

        }else {
            /*根据新增的车辆识别代号生成二维码*/
//                                    environmentalPrintService.createQRCode(envPrintData.getVehicleIdentificationNumber());
           createQRCode(encft.getVin());
            /*根据新增的车辆识别代号生成条形码*/
//                                    environmentalPrintService.createBarCode(envPrintData.getVehicleIdentificationNumber());
            createBarCode(encft.getVin());
        }

        // 寻找上传的模板
//        String templatePath = environmentalPrintService.getTemplatePath(encft.getVehicleDesign(),
//                TemplateKindEnum.UPLOAD.getValue());

        String templatePath = getTemplatePath(encft.getTemplateType(),
                TemplateKindEnum.UPLOAD.getValue());

        if (StringUtils.isNotEmpty(templatePath)) {
            String fileName = templatePath.substring(0, templatePath.indexOf("|"));
            String filePath = ResourceUtil.getConfigByName("realpath") + fileName;
            File file = new File(filePath);
            if (!file.exists()) {
                message += "车辆识别代号为" + encft.getVin() + "的模板" + encft.getTemplateType() + "已损坏\n";
            } else {
                //createWord(encft, templatePath, TemplateKindEnum.UPLOAD.getValue()); // TemplateKindEnum.UPLOAD.getValue()传不为空的数字
                //先获取型式检验信息
                // 根据对应的环保信息公开基础数据的id找到对应的型式检验信息
                // String sql="select * from syxy_inspection_information where ENVIRONMENTAL_ID =? order by ORDER_NUMBER";
                QueryWrapper<SyxyInspectionInformationEO> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq(SyxyInspectionInformationEO.SYXY_INSPECTION_INFORMATION_ENVIRONMENTAL_ID,encft.getEnvid());
                List<SyxyInspectionInformationEO> informations = inspectionInformationEOService.list(queryWrapper);
                 try {
                     String printType = "2"; // 1 表示打印；2表示上传
                     String result = createWord(encft,encft,informations, templatePath, TemplateKindEnum.UPLOAD.getValue(),qyname,qyid,printType);
                 }catch (Exception e){
                     e.printStackTrace();
                 }
                // 创建模板后进行pdf报送
                String realpath = ResourceUtil.getConfigByName("previewPath");

                //格式化当前日期
                Date d = new Date();
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                //按企业和日期进行目录的分级
                realpath = realpath + qyid +"/env/" + sdf.format(d) + "/";
                realpath = realpath + "envData_upload_" + encft.getId() + ".pdf";// 对应的pdf
                System.out.println("============pdfPath=====================:"+realpath);
               // String pdfPath = realpath + "envData_" + vin + ".pdf";// 对应的pdf
//                String pdfName = encft.getDiscernNumber() + ".pdf";
                String pdfName = encft.getVin() + ".pdf";
                File pdfFile = new File(realpath);
                // 文件存在直接进行pdf申报
                try{
                    if (pdfFile.exists()) {
                        FtpResultBean resultBean = doPdfDeclare(pdfName, pdfFile,qyid);
                        if (resultBean.isSuccess()) {
                            message = "车辆识别代号为" + encft.getVin() + "的pdf报送成功\n";
                            // 申报完成后改变状态
                            updatePdfDeclare(encft);

//                            systemService.addLog("EnvironmentalDeclareController.doDeclarePdf;车辆识别代号为" + encft.getModelNumber() + "的环保随车清单pdf报送成功",
//                                    Globals.Log_Type_UPLOAD, Globals.Log_Leavel_INFO);
                        } else {
                            message = resultBean.getMessage();
                        }
                    } else {
                        message = "车辆识别代号为" + encft.getVin() + "的pdf受损，请稍后再试\n";
                    }
                }catch (Exception e){
                    e.printStackTrace();
                    message = "车辆识别代号为" + encft.getVin() + "的pdf受损，请稍后再试\n";
                }
            }
        } else {
            message += "车辆识别代号为" + encft.getVin() + "的模板" + encft.getVehicleDesign() + "未找到\n";
        }
        return message;
    }

    private void updatePdfDeclare(SyxyModelEnviromentalDataEO encft) {
        // 如果pdf已经申报完了，那摩这条数据整体已经申报结束进入已申报页面，否则要等pdf申报结束后才算申报结束，到已申报页面
//        if (encftEntity.getVinState() != null && EnvironmentApplyStatus.APPLY_YES == encftEntity.getVinState()) {
//            encftEntity.setState(EnvironmentApplyStatus.APPLY_YES);// 已申报
//            systemService.addLog("EnvironmentalDeclareServiceImpl.updatePdfDeclare;车辆识别代号为"+encftEntity.getDiscernNumber()+"的环保随车清单PDF申报成功后进入已申报模块",Globals.Log_Type_UPLOAD, Globals.Log_Leavel_INFO);
//        }else{
//            systemService.addLog("EnvironmentalDeclareServiceImpl.updatePdfDeclare&车辆识别代号为"+encftEntity.getDiscernNumber()+"的环保随车清单PDF申报成功",Globals.Log_Type_UPLOAD, Globals.Log_Leavel_INFO);
//        }
        encft.setPdfState(1); // 已申报
        encft.setPdfUploadDate(new Date());
        // 更新数据状态
        saveOrUpdate(encft);
    }


    // 进行pdf报送
    public FtpResultBean doPdfDeclare(String pdfName, File file,String qyid) throws FileNotFoundException {
        FileInputStream in = new FileInputStream(file);
        String pdfDeclareUrl = ResourceUtil.getConfigByName("pdfDeclareUrl");
        String enterpriseName = "";
        String enterprisePassword = "";
        // String enterpriseName=ResourceUtil.getConfigByName("enterpriseName");
        int pdfDeclareProt = Integer.parseInt(ResourceUtil.getConfigByName("pdfDeclareProt"));
        // String
        // enterprisePassword=ResourceUtil.getConfigByName("enterprisePassword");
        String pdfDeclarePath = ResourceUtil.getConfigByName("pdfDeclarePath");
//        List<AccountSetEntity> list = loadAll(AccountSetEntity.class);
//        Map<String, Object> usermap = (Map<String, Object>) request.getSession().getAttribute("usermap");
//        String qyid = usermap.get("USERNAME").toString();

        QueryWrapper<SyxyAccountSetEO>  accountWrapper = new QueryWrapper<>();
        accountWrapper.eq(SyxyAccountSetEO.SYXY_ACCOUNT_SET_QYID,qyid); //TODO 测试

//            manufid= "62188593-x";        //TODO del
//            password = "5jCxqtqtTCGTwk3n";//TODO del

        List<SyxyAccountSetEO> list = iSyxyAccountSetEOService.list(accountWrapper);
        if (!list.isEmpty() && list.size() > 0) {
//            enterpriseName = list.get(0).getEPdfUseName();
            enterpriseName = list.get(0).getEPdfUsename();
            enterprisePassword = list.get(0).getEPdfPassword();
        }
//        enterpriseName ="62188593-x";           //TODO del
//        enterprisePassword ="5jCxqtqtTCGTwk3n"; //TODO del

        FtpResultBean resultBean = FtpUtil.uploadFile(pdfDeclareUrl, pdfDeclareProt, enterpriseName, enterprisePassword,
                pdfDeclarePath, pdfName, in);
        return resultBean;
    }


}
